(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    161669,       3784]
NotebookOptionsPosition[    150606,       3616]
NotebookOutlinePosition[    151167,       3635]
CellTagsIndexPosition[    151124,       3632]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"SetDirectory", "[", 
  RowBox[{"NotebookDirectory", "[", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.843115645515818*^9, 3.84311566449924*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"0577225e-bc14-4519-9011-ca829fa0147b"],

Cell[BoxData["\<\"/home/dbfranzosi/Dropbox/GM_Shift/Diogo/HEPMDB/\
NMSSMgldsHZeros_UFO_py2\"\>"], "Output",
 CellChangeTimes->{3.844874709778769*^9},
 CellLabel->"Out[1]=",ExpressionUUID->"bdb68138-5f2d-4c3a-a721-90e77ff97d38"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Analytic part", "Title",
 CellChangeTimes->{{3.7351130155776873`*^9, 
  3.7351130420519333`*^9}},ExpressionUUID->"2b3e8072-ce96-4699-b342-\
bc159e2e5660"],

Cell["\<\
NB I fixed the sign of A\[Lambda]i in the neutralino mass matrix since <Hu.\
\[Epsilon].Hd> = -vu vd/2\
\>", "Text",
 CellChangeTimes->{{3.7787404839009075`*^9, 3.778740566494726*^9}, {
  3.7787454371013994`*^9, 3.778745537701178*^9}, {3.783771219128502*^9, 
  3.783771284045347*^9}, {3.7839237598627367`*^9, 3.7839237618703423`*^9}, {
  3.783925108107284*^9, 
  3.783925111244494*^9}},ExpressionUUID->"a4b170be-d10e-4be8-804b-\
73cbbc4ba106"],

Cell[CellGroupData[{

Cell["Initialization", "Subsection",
 CellChangeTimes->{{3.7492269511153555`*^9, 
  3.7492269545655527`*^9}},ExpressionUUID->"93c0f94e-be0e-436f-826b-\
b4fe253ddc21"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"$thisdir", " ", "=", " ", 
   RowBox[{"NotebookDirectory", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetDirectory", "[", "$thisdir", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.7351129966236534`*^9, 3.735113002333264*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"05a527f5-d989-4de4-a651-2e6d404792c9"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "Conjugate", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vs", "\[Conjugate]"}], "=", "vs"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"hs", "\[Conjugate]"}], "=", "hs"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"as", "\[Conjugate]"}], "=", "as"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vd", "\[Conjugate]"}], "=", "vd"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"hd", "\[Conjugate]"}], "=", "hd"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ad", "\[Conjugate]"}], "=", "ad"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vu", "\[Conjugate]"}], "=", "vu"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"hu", "\[Conjugate]"}], "=", "hu"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"au", "\[Conjugate]"}], "=", "au"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Lambda]", "\[Conjugate]"}], "=", "\[Lambda]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"k", "\[Conjugate]"}], "=", "k"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"A\[Lambda]", "\[Conjugate]"}], "=", "A\[Lambda]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Ak", "\[Conjugate]"}], "=", "Ak"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MB", "\[Conjugate]"}], "=", "MB"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MW", "\[Conjugate]"}], "=", "MW"}], ";"}], " "}]}], "Input",
 CellChangeTimes->{{3.7350080081443167`*^9, 3.7350080279563513`*^9}, {
   3.735008065193617*^9, 3.7350080661140184`*^9}, {3.7350081089672937`*^9, 
   3.735008291206814*^9}, {3.7350085928957434`*^9, 3.7350086145017815`*^9}, {
   3.735009028589909*^9, 3.7350090405083303`*^9}, {3.735012954726805*^9, 
   3.7350130083782997`*^9}, {3.735013096892455*^9, 3.7350131160960884`*^9}, {
   3.7350163256607323`*^9, 3.735016336331151*^9}, 3.73502328269078*^9, {
   3.749207349229375*^9, 3.7492074562821712`*^9}, 3.749207775849752*^9, 
   3.749219201531104*^9},
 CellLabel->"In[4]:=",ExpressionUUID->"7f32c315-51df-4131-b3eb-e332fbecf302"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"S", " ", "=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"vs", " ", "+", " ", "hs", " ", "+", " ", 
      RowBox[{"I", " ", "as"}]}], ")"}], "/", 
    RowBox[{"\[Sqrt]", "2"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Hd", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"vd", " ", "+", " ", "hd", " ", "+", " ", 
        RowBox[{"I", " ", "ad"}]}], ")"}], "/", 
      RowBox[{"\[Sqrt]", "2"}]}], ",", " ", "hdm"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Hu", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"hup", ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"vu", " ", "+", " ", "hu", " ", "+", " ", 
        RowBox[{"I", " ", "au"}]}], ")"}], "/", 
      RowBox[{"\[Sqrt]", "2"}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Epsilon]", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "0"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"zerofield", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"hs", "\[Rule]", "0"}], ",", " ", 
     RowBox[{"as", "\[Rule]", " ", "0"}], ",", " ", 
     RowBox[{"hd", "\[Rule]", "0"}], ",", " ", 
     RowBox[{"ad", "\[Rule]", " ", "0"}], ",", " ", 
     RowBox[{"hu", "\[Rule]", "0"}], ",", " ", 
     RowBox[{"au", "\[Rule]", " ", "0"}], ",", " ", 
     RowBox[{"hdm", "\[Rule]", " ", "0"}], ",", " ", 
     RowBox[{"hup", "\[Rule]", " ", "0"}]}], " ", "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.7350082854036036`*^9, 3.735008429891057*^9}, 
   3.7350084689379263`*^9, {3.7350086241113987`*^9, 3.7350086723310833`*^9}, {
   3.7350111313508024`*^9, 3.7350111399932175`*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"b9eb888a-ad4c-4941-9903-a159f85e73e1"]
}, Closed]],

Cell[CellGroupData[{

Cell["Potential, tadpoles and mass matrices", "Subsection",
 CellChangeTimes->{{3.7350198558315334`*^9, 3.7350198642087483`*^9}, {
  3.7492250008178043`*^9, 3.7492250252462015`*^9}, {3.7492269614569464`*^9, 
  3.7492269724375744`*^9}},ExpressionUUID->"3aaa7217-7e77-4cca-9c01-\
b17b3344e060"],

Cell["\<\
I must put the potential and the mass matrices BEFORE the solutions to avoid \
problems with complex conjugation.\
\>", "Text",
 CellChangeTimes->{{3.7492236739149103`*^9, 3.7492237001644115`*^9}, {
  3.7492239612813463`*^9, 
  3.7492239884238987`*^9}},ExpressionUUID->"239fd2f6-1833-41df-8b13-\
f35c4d74f2dc"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"VF", " ", "=", " ", 
   RowBox[{
    RowBox[{
     SuperscriptBox["\[Lambda]", "2"], 
     RowBox[{"S", "\[Conjugate]"}], " ", "S", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"Hd", "\[Conjugate]"}], ".", "Hd"}], " ", "+", " ", 
       RowBox[{
        RowBox[{"Hu", "\[Conjugate]"}], ".", "Hu"}]}], ")"}]}], " ", "+", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Lambda]", " ", 
         RowBox[{"Hu", ".", "\[Epsilon]", ".", "Hd"}]}], " ", "+", " ", 
        RowBox[{"k", " ", 
         SuperscriptBox["S", "2"]}]}], ")"}], "\[Conjugate]"}], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"\[Lambda]", " ", 
        RowBox[{"Hu", ".", "\[Epsilon]", ".", "Hd"}]}], " ", "+", " ", 
       RowBox[{"k", " ", 
        SuperscriptBox["S", "2"]}]}], ")"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"VD", " ", "=", " ", 
   RowBox[{
    RowBox[{
     SuperscriptBox["g2", "2"], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Hu", "\[Conjugate]"}], ".", "Hd"}], ")"}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Hd", "\[Conjugate]"}], ".", "Hu"}], ")"}], "/", "2"}]}], " ",
     "+", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["g1", "2"], "+", " ", 
       SuperscriptBox["g2", "2"]}], ")"}], 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Hu", "\[Conjugate]"}], ".", "Hu"}], " ", "-", " ", 
         RowBox[{
          RowBox[{"Hd", "\[Conjugate]"}], ".", "Hd"}]}], ")"}], "2"], "/", 
      "8"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"VS", " ", "=", " ", 
   RowBox[{
    RowBox[{"m2u", " ", 
     RowBox[{
      RowBox[{"Hu", "\[Conjugate]"}], ".", "Hu"}]}], " ", "+", "  ", 
    RowBox[{"m2d", " ", 
     RowBox[{
      RowBox[{"Hd", "\[Conjugate]"}], ".", "Hd"}]}], " ", "+", "  ", 
    RowBox[{"m2s", " ", 
     RowBox[{"S", "\[Conjugate]"}], " ", "S"}], " ", "+", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"\[Lambda]", " ", "A\[Lambda]", " ", 
       RowBox[{"Hu", ".", "\[Epsilon]", ".", "Hd"}], " ", "S"}], " ", "+", 
      " ", 
      RowBox[{"k", " ", "Ak", " ", 
       RowBox[{
        SuperscriptBox["S", "3"], "/", "3"}]}]}], ")"}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"\[Lambda]", " ", "A\[Lambda]", " ", 
        RowBox[{"Hu", ".", "\[Epsilon]", ".", "Hd"}], " ", "S"}], " ", "+", 
       " ", 
       RowBox[{"k", " ", "Ak", " ", 
        RowBox[{
         SuperscriptBox["S", "3"], "/", "3"}]}]}], ")"}], 
     "\[Conjugate]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"V", " ", "=", " ", 
   RowBox[{"VF", " ", "+", " ", "VD", " ", "+", " ", "VS"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.73500847665994*^9, 3.7350085785749187`*^9}, {
  3.735008695528324*^9, 3.7350090931740227`*^9}},
 CellLabel->"In[25]:=",ExpressionUUID->"ebf62237-2bb4-4895-9b14-61df5eb1fb22"],

Cell["\<\
Tadpoles (to be satisfied when setting the coefficients m2u, m2d, m2s)\
\>", "Text",
 CellChangeTimes->{{3.749224183351048*^9, 3.749224186985256*^9}, {
  3.749224728916252*^9, 
  3.7492247898437376`*^9}},ExpressionUUID->"459d94ed-7728-4fd2-b35c-\
a68b48647d95"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tadpoles", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"D", "[", 
        RowBox[{"V", ",", " ", "hu"}], "]"}], ",", " ", 
       RowBox[{"D", "[", 
        RowBox[{"V", ",", " ", "hd"}], "]"}], ",", " ", 
       RowBox[{"D", "[", 
        RowBox[{"V", ",", " ", "hs"}], "]"}]}], "}"}], "/.", "zerofield"}], "//",
     "FullSimplify"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.7492210826736994`*^9, 3.7492211955661564`*^9}, {
  3.749222699143156*^9, 3.749222703386399*^9}, {3.7492241677361546`*^9, 
  3.7492241768226748`*^9}},
 CellLabel->"In[29]:=",ExpressionUUID->"3de2ae8e-b029-4d40-9979-d689a5ddc999"],

Cell["\<\
3 x 3 scalar Higgs square mass matrix = mass2H (all of this before the \
tadpole cond. is satisfied or the spectrum for the charged and pseudoscalars \
is fixed).
Ordering: Hd, Hu, S\
\>", "Text",
 CellChangeTimes->{{3.735019877078771*^9, 3.735019885565186*^9}, {
   3.7350199210708485`*^9, 3.735019924705655*^9}, {3.7350204826250343`*^9, 
   3.7350204941378546`*^9}, {3.735028503612152*^9, 3.7350285057493553`*^9}, {
   3.735360396935999*^9, 3.7353603969852057`*^9}, {3.7492247367977033`*^9, 
   3.7492247379057665`*^9}, {3.7492247937469606`*^9, 3.7492248439378314`*^9}, 
   3.7783253366821537`*^9},ExpressionUUID->"61d5996e-1fb1-495a-a2c9-\
5cf2390cb698"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mass2H", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"2", " ", 
           RowBox[{"Coefficient", "[", 
            RowBox[{"V", ",", " ", 
             SuperscriptBox["hd", "2"]}], "]"}]}], ",", 
          RowBox[{"Coefficient", "[", 
           RowBox[{"V", ",", " ", 
            RowBox[{"hd", " ", "hu"}]}], "]"}], ",", 
          RowBox[{"Coefficient", "[", 
           RowBox[{"V", ",", " ", 
            RowBox[{"hd", " ", "hs"}]}], "]"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Coefficient", "[", 
           RowBox[{"V", ",", " ", 
            RowBox[{"hu", " ", "hd"}]}], "]"}], ",", 
          RowBox[{"2", 
           RowBox[{"Coefficient", "[", 
            RowBox[{"V", ",", " ", 
             SuperscriptBox["hu", "2"]}], "]"}]}], ",", 
          RowBox[{"Coefficient", "[", 
           RowBox[{"V", ",", " ", 
            RowBox[{"hu", " ", "hs"}]}], "]"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Coefficient", "[", 
           RowBox[{"V", ",", " ", 
            RowBox[{"hs", " ", "hd"}]}], "]"}], ",", 
          RowBox[{"Coefficient", "[", 
           RowBox[{"V", ",", " ", 
            RowBox[{"hs", " ", "hu"}]}], "]"}], ",", 
          RowBox[{"2", " ", 
           RowBox[{"Coefficient", "[", 
            RowBox[{"V", ",", " ", 
             SuperscriptBox["hs", "2"]}], "]"}]}]}], "}"}]}], "}"}], " ", "/.",
       "zerofield"}], "//", "FullSimplify"}], "//", "Expand"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.7350110438014483`*^9, 3.7350111183851795`*^9}, {
   3.73501117546768*^9, 3.735011194796114*^9}, {3.7350113569271984`*^9, 
   3.735011437829941*^9}, {3.735011962318462*^9, 3.735011970118476*^9}, {
   3.7350120042201357`*^9, 3.7350120301941814`*^9}, {3.7350122434465556`*^9, 
   3.7350122568625793`*^9}, {3.7350124001020308`*^9, 
   3.7350124259200764`*^9}, {3.735012687669936*^9, 3.735012705875168*^9}, 
   3.7350307983092904`*^9, {3.7350314961826935`*^9, 3.735031524168294*^9}, {
   3.749219426419967*^9, 3.749219454466571*^9}},
 CellLabel->"In[30]:=",ExpressionUUID->"bbd21728-6340-46f4-8baa-a49d03aa3ead"],

Cell["\<\
2 x 2 pseudoscalar Higgs square mass matrix = mass2A (mass2AwithGold is not \
yet with zero det, since I have not yet imposed the tadpole condition).\
\>", "Text",
 CellChangeTimes->{{3.735019877078771*^9, 3.7350199300876637`*^9}, {
   3.7350285137209697`*^9, 3.7350285158581734`*^9}, {3.7492227595716124`*^9, 
   3.7492227629498053`*^9}, {3.749224851837283*^9, 3.7492248971518755`*^9}, 
   3.778325344818245*^9},ExpressionUUID->"53b2d8f2-262b-40c4-bee9-\
88b26bf7a1a8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mass2AwithGold", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"2", " ", 
           RowBox[{"Coefficient", "[", 
            RowBox[{"V", ",", " ", 
             SuperscriptBox["ad", "2"]}], "]"}]}], ",", 
          RowBox[{"Coefficient", "[", 
           RowBox[{"V", ",", " ", 
            RowBox[{"ad", " ", "au"}]}], "]"}], ",", 
          RowBox[{"Coefficient", "[", 
           RowBox[{"V", ",", " ", 
            RowBox[{"ad", " ", "as"}]}], "]"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Coefficient", "[", 
           RowBox[{"V", ",", " ", 
            RowBox[{"au", " ", "ad"}]}], "]"}], ",", 
          RowBox[{"2", 
           RowBox[{"Coefficient", "[", 
            RowBox[{"V", ",", " ", 
             SuperscriptBox["au", "2"]}], "]"}]}], ",", 
          RowBox[{"Coefficient", "[", 
           RowBox[{"V", ",", " ", 
            RowBox[{"au", " ", "as"}]}], "]"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Coefficient", "[", 
           RowBox[{"V", ",", " ", 
            RowBox[{"as", " ", "ad"}]}], "]"}], ",", 
          RowBox[{"Coefficient", "[", 
           RowBox[{"V", ",", " ", 
            RowBox[{"as", " ", "au"}]}], "]"}], ",", 
          RowBox[{"2", " ", 
           RowBox[{"Coefficient", "[", 
            RowBox[{"V", ",", " ", 
             SuperscriptBox["as", "2"]}], "]"}]}]}], "}"}]}], "}"}], " ", "/.",
       "zerofield"}], "//", "Simplify"}], "//", "Expand"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.7350110438014483`*^9, 3.7350111183851795`*^9}, {
   3.73501117546768*^9, 3.735011194796114*^9}, {3.7350113569271984`*^9, 
   3.735011437829941*^9}, {3.735011962318462*^9, 3.735011970118476*^9}, {
   3.7350120042201357`*^9, 3.7350120301941814`*^9}, {3.7350122434465556`*^9, 
   3.7350122568625793`*^9}, {3.7350123477483387`*^9, 3.73501234832554*^9}, {
   3.7350124061080413`*^9, 3.7350124639539433`*^9}, {3.735012672257109*^9, 
   3.7350126756735153`*^9}, {3.735015133736639*^9, 3.7350151404924507`*^9}, 
   3.7350308038366065`*^9, {3.7350315459265385`*^9, 3.735031551286845*^9}, {
   3.7492194631320667`*^9, 3.7492194873894544`*^9}},
 CellLabel->"In[31]:=",ExpressionUUID->"296f655f-1fc6-422a-8dac-12845181f193"],

Cell[BoxData[
 RowBox[{
  RowBox[{"R\[Beta]", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"cos\[Beta]", ",", " ", "sin\[Beta]", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "sin\[Beta]"}], ",", "cos\[Beta]", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.7350139981668434`*^9, 3.7350140561053457`*^9}, {
  3.7350315629165106`*^9, 3.7350316087481318`*^9}, {3.735286538306705*^9, 
  3.735286566801146*^9}},
 CellLabel->"In[32]:=",ExpressionUUID->"9ce01d7f-8ca2-44f5-8265-59fae72828c8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mass2A", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"R\[Beta]", "\[Transpose]"}], ".", "mass2AwithGold", ".", 
           "R\[Beta]"}], ")"}], "\[LeftDoubleBracket]", 
         RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}], "//", 
        "Simplify"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"R\[Beta]", "\[Transpose]"}], ".", "mass2AwithGold", ".", 
           "R\[Beta]"}], ")"}], "\[LeftDoubleBracket]", 
         RowBox[{"2", ",", "3"}], "\[RightDoubleBracket]"}], "//", 
        "Simplify"}]}], "}"}], ",", "\[IndentingNewLine]", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"R\[Beta]", "\[Transpose]"}], ".", "mass2AwithGold", ".", 
           "R\[Beta]"}], ")"}], "\[LeftDoubleBracket]", 
         RowBox[{"3", ",", "2"}], "\[RightDoubleBracket]"}], "//", 
        "Simplify"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"R\[Beta]", "\[Transpose]"}], ".", "mass2AwithGold", ".", 
           "R\[Beta]"}], ")"}], "\[LeftDoubleBracket]", 
         RowBox[{"3", ",", "3"}], "\[RightDoubleBracket]"}], "//", 
        "Simplify"}]}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.735013953956366*^9, 3.735013975671604*^9}, {
   3.7350141068834343`*^9, 3.7350141453999023`*^9}, {3.7350149275314765`*^9, 
   3.7350151153890066`*^9}, {3.73501515172447*^9, 3.735015170865704*^9}, {
   3.735030894012764*^9, 3.735030903842326*^9}, 3.749224078185033*^9},
 CellLabel->"In[33]:=",ExpressionUUID->"ba5a7955-6ebc-4a46-9fa0-c00bd6f8ce65"],

Cell["\<\
Charged Higgs square mass (mass2HpmwithGold is not yet with zero det, since I \
have not yet imposed the tadpole condition).\
\>", "Text",
 CellChangeTimes->{{3.735019877078771*^9, 3.735019954501707*^9}, {
  3.735028525857791*^9, 3.735028527480194*^9}, {3.749222891993187*^9, 
  3.7492228940903063`*^9}, {3.7492239305265875`*^9, 3.749223933640765*^9}, {
  3.7492249134428067`*^9, 
  3.749224925431493*^9}},ExpressionUUID->"c9d957b2-1021-4793-9009-\
fe382c9bb179"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Carefull", " ", "taking", " ", "the", " ", "coefficients", " ", "of", " ",
     "a", " ", "complex", " ", 
    RowBox[{"conjugate", ":", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Coefficient", "[", 
       RowBox[{"V", ",", 
        RowBox[{
         RowBox[{"hup", "\[Conjugate]"}], " ", 
         RowBox[{"hdm", "\[Conjugate]"}]}]}], "]"}], " ", "misses", "  ", 
      RowBox[{"Coefficient", "[", 
       RowBox[{"V", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"hup", " ", "hdm"}], ")"}], "\[Conjugate]"}]}], "]"}], " ", 
      "and", " ", 
      RowBox[{"viceversa", ".", "\[IndentingNewLine]", "I"}], " ", "just", 
      " ", "use", " ", 
      RowBox[{"Coefficient", "[", 
       RowBox[{"V", ",", " ", 
        RowBox[{"hdm", " ", "hup"}]}], "]"}], " ", "since", " ", "I", " ", 
      "have", " ", "chosen", " ", "it", " ", "to", " ", "be", " ", 
      RowBox[{"real", "."}]}]}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"mass2HpmwithGold", "=", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Coefficient", "[", 
            RowBox[{"V", ",", " ", 
             RowBox[{
              RowBox[{"hup", "\[Conjugate]"}], " ", "hup"}]}], "]"}], ",", 
           RowBox[{"Coefficient", "[", 
            RowBox[{"V", ",", " ", 
             RowBox[{"hup", " ", "hdm"}]}], "]"}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Coefficient", "[", 
            RowBox[{"V", ",", " ", 
             RowBox[{"hdm", " ", "hup"}]}], "]"}], ",", 
           RowBox[{"Coefficient", "[", 
            RowBox[{"V", ",", " ", 
             RowBox[{"hdm", " ", 
              RowBox[{"hdm", "\[Conjugate]"}]}]}], "]"}]}], " ", "}"}]}], 
        "}"}], " ", "/.", "zerofield"}], "//", "Simplify"}], "//", 
     "Expand"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.7350152182293873`*^9, 3.7350152345158157`*^9}, {
   3.735015269163477*^9, 3.735015438954175*^9}, {3.735015676308592*^9, 
   3.7350156896154156`*^9}, {3.7350188825066233`*^9, 
   3.7350190116124506`*^9}, {3.735019048834116*^9, 3.7350191420130796`*^9}, 
   3.735030914481935*^9, 3.73520364962082*^9, {3.749219532547037*^9, 
   3.749219576882573*^9}},
 CellLabel->"In[34]:=",ExpressionUUID->"f332ed9f-6c5d-49e2-94fb-98d1d39a904b"],

Cell["\<\
2 x 2 Charginos mass mass matrix = masschar
Ordering: W, H\
\>", "Text",
 CellChangeTimes->{{3.735019877078771*^9, 3.7350199300876637`*^9}, {
  3.7350199762793455`*^9, 3.735019982160556*^9}, {3.7350200186646194`*^9, 
  3.735020029397438*^9}, {3.7350204528757825`*^9, 
  3.7350204628598003`*^9}},ExpressionUUID->"90065984-e02d-404a-81c8-\
a081b7871ca2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"masschar", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"MW", ",", " ", 
       RowBox[{
        RowBox[{"\[Sqrt]", "2"}], " ", "mw", " ", "sin\[Beta]"}]}], "}"}], 
     ",", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"\[Sqrt]", "2"}], " ", "mw", " ", "cos\[Beta]"}], ",", " ", 
       RowBox[{"\[Lambda]", " ", 
        RowBox[{"vs", " ", "/", 
         RowBox[{"\[Sqrt]", "2"}]}]}]}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.575277132625*^9, 3.57527714571875*^9}, {
   3.575277311421875*^9, 3.57527736209375*^9}, {3.5752775224375*^9, 
   3.575277592734375*^9}, {3.5752776684375*^9, 3.5752777060625*^9}, 
   3.575277750265625*^9, {3.575277803390625*^9, 3.57527791621875*^9}, {
   3.5752780689375*^9, 3.575278264484375*^9}, {3.575278314359375*^9, 
   3.57527850334375*^9}, {3.575278668078125*^9, 3.575278790625*^9}, 
   3.575279135578125*^9, {3.575279365890625*^9, 3.57527939409375*^9}, {
   3.575280808828125*^9, 3.5752808305625*^9}, {3.5752808835625*^9, 
   3.575280925296875*^9}, {3.57528129528125*^9, 3.5752813020625*^9}, {
   3.575281340015625*^9, 3.57528151040625*^9}, {3.575282458453125*^9, 
   3.575282464734375*^9}, {3.575282502765625*^9, 3.57528255175*^9}, {
   3.5752865158125*^9, 3.575286517203125*^9}, {3.575344770890625*^9, 
   3.57534477190625*^9}, {3.57534480559375*^9, 3.575344853140625*^9}, {
   3.57534490553125*^9, 3.575344907515625*^9}, {3.5753449410625*^9, 
   3.575344987640625*^9}, {3.57534568446875*^9, 3.575345689015625*^9}, {
   3.575345889421875*^9, 3.57534589009375*^9}, 3.5753459378125*^9, {
   3.575346182890625*^9, 3.5753462145625*^9}, {3.734933823066863*^9, 
   3.734933834327507*^9}, {3.734933916153187*^9, 3.734934005127276*^9}, {
   3.7349351514768434`*^9, 3.7349352555007935`*^9}, {3.73493528603854*^9, 
   3.734935411110694*^9}, {3.734935546510438*^9, 3.734935677477929*^9}, {
   3.7349358155768275`*^9, 3.7349359580699778`*^9}, {3.734936270224832*^9, 
   3.7349363807991567`*^9}, {3.7349364522942457`*^9, 
   3.7349364770416613`*^9}, {3.734936530918743*^9, 3.734936544550523*^9}, 
   3.734936586310911*^9, {3.734936622920005*^9, 3.7349366831454496`*^9}, {
   3.7349367378285775`*^9, 3.7349367860773373`*^9}, {3.73493685029401*^9, 
   3.7349370218118205`*^9}, {3.7349370723267097`*^9, 
   3.7349372471417084`*^9}, {3.734937316261662*^9, 3.7349373179097567`*^9}, 
   3.734937553354223*^9, {3.734937680006467*^9, 3.7349376822185936`*^9}, {
   3.734946474161264*^9, 3.7349465058137197`*^9}, {3.7349472798256793`*^9, 
   3.7349472822124834`*^9}, {3.7349474107879095`*^9, 
   3.7349474257639356`*^9}, {3.734947522858506*^9, 3.734947541672139*^9}, {
   3.7349479017832394`*^9, 3.7349479285287685`*^9}, {3.7350317499382076`*^9, 
   3.735031776130706*^9}, {3.735286613631914*^9, 3.735286630403232*^9}, 
   3.735361689334296*^9, {3.7353619694016247`*^9, 3.7353620077428417`*^9}, 
   3.783925251683366*^9},
 CellLabel->"In[35]:=",ExpressionUUID->"52c02210-fa62-48b4-be7e-fb1ee343ee1f"],

Cell["\<\
Extended Neutralino masses matrix including 1, (2, 3) pGLDs
Ordering: B, W, Hd, Hu, S, \[Eta]1, (\[Eta]2, \[Eta]3)\
\>", "Text",
 CellChangeTimes->{{3.735019877078771*^9, 3.7350199300876637`*^9}, {
  3.7350199762793455`*^9, 3.735019982160556*^9}, {3.7350200347170477`*^9, 
  3.735020048367072*^9}, {3.7350203704608374`*^9, 3.735020396278883*^9}, {
  3.7350204410665617`*^9, 3.7350204505201783`*^9}, {3.7350317854782405`*^9, 
  3.7350317937417126`*^9}, {3.748858658722608*^9, 3.748858699447421*^9}, {
  3.749223527429531*^9, 3.7492235409943075`*^9}, {3.78368706691803*^9, 
  3.783687071443412*^9}, {3.783923793149337*^9, 3.783923829307188*^9}, {
  3.783925963135078*^9, 3.7839259637582893`*^9}, {3.783935135515435*^9, 
  3.783935162866384*^9}},ExpressionUUID->"2267a51e-6c61-4908-b153-\
ca67fe0e4ddf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"massneu3", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"MB", " ", ",", " ", "0", ",", " ", 
       RowBox[{
        RowBox[{"-", "mz"}], " ", "s\[Theta]", " ", "cos\[Beta]"}], ",", " ", 
       RowBox[{"mz", " ", "s\[Theta]", " ", "sin\[Beta]"}], ",", " ", "0", 
       ",", "  ", 
       RowBox[{
        RowBox[{"-", " ", "MB1"}], " ", 
        RowBox[{"DY", "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Sqrt]", "2"}], " ", "f1"}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{"-", "MB2"}], " ", 
        RowBox[{"DY", "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Sqrt]", "2"}], " ", "f2"}], ")"}]}]}], ",", " ", 
       RowBox[{
        RowBox[{"-", "MB3"}], " ", 
        RowBox[{"DY", "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Sqrt]", "2"}], " ", "f3"}], ")"}]}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"0", ",", " ", "MW", ",", " ", 
       RowBox[{"mz", " ", "c\[Theta]", " ", "cos\[Beta]"}], ",", " ", 
       RowBox[{
        RowBox[{"-", "mz"}], " ", "c\[Theta]", " ", "sin\[Beta]"}], ",", " ", 
       "0", ",", " ", 
       RowBox[{
        RowBox[{"-", "MW1"}], " ", 
        RowBox[{"DT3", "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Sqrt]", "2"}], " ", "f1"}], ")"}]}]}], ",", " ", 
       RowBox[{
        RowBox[{"-", "MW2"}], " ", 
        RowBox[{"DT3", "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Sqrt]", "2"}], " ", "f2"}], ")"}]}]}], ",", " ", 
       RowBox[{
        RowBox[{"-", "MW3"}], " ", 
        RowBox[{"DT3", "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Sqrt]", "2"}], " ", "f3"}], ")"}]}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "mz"}], " ", "s\[Theta]", " ", "cos\[Beta]"}], ",", 
       RowBox[{"mz", " ", "c\[Theta]", " ", "cos\[Beta]"}], ",", " ", "0", 
       ",", " ", 
       RowBox[{
        RowBox[{"-", "\[Lambda]"}], " ", 
        RowBox[{"vs", "/", 
         RowBox[{"\[Sqrt]", "2"}]}]}], ",", 
       RowBox[{
        RowBox[{"-", "\[Lambda]"}], " ", 
        RowBox[{"vu", "/", 
         RowBox[{"\[Sqrt]", "2"}]}]}], ",", "  ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m2d1", " ", 
            RowBox[{"vd", "/", 
             RowBox[{"\[Sqrt]", "2"}]}]}], " ", "-", " ", 
           RowBox[{"\[Lambda]", " ", "A\[Lambda]1", " ", "vs", " ", 
            RowBox[{"vu", "/", "2"}]}]}], ")"}]}], "/", "f1"}], ",", " ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m2d2", " ", 
            RowBox[{"vd", "/", 
             RowBox[{"\[Sqrt]", "2"}]}]}], " ", "-", " ", 
           RowBox[{"\[Lambda]", " ", "A\[Lambda]2", " ", "vs", " ", 
            RowBox[{"vu", "/", "2"}]}]}], ")"}]}], "/", "f2"}], ",", " ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m2d3", " ", 
            RowBox[{"vd", "/", 
             RowBox[{"\[Sqrt]", "2"}]}]}], " ", "-", " ", 
           RowBox[{"\[Lambda]", " ", "A\[Lambda]3", " ", "vs", " ", 
            RowBox[{"vu", "/", "2"}]}]}], ")"}]}], "/", "f3"}]}], " ", "}"}], 
     ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"mz", " ", "s\[Theta]", " ", "sin\[Beta]"}], ",", 
       RowBox[{
        RowBox[{"-", "mz"}], " ", "c\[Theta]", " ", "sin\[Beta]"}], ",", " ", 
       RowBox[{
        RowBox[{"-", "\[Lambda]"}], " ", 
        RowBox[{"vs", "/", 
         RowBox[{"\[Sqrt]", "2"}]}]}], ",", "0", ",", 
       RowBox[{
        RowBox[{"-", "\[Lambda]"}], " ", 
        RowBox[{"vd", "/", 
         RowBox[{"\[Sqrt]", "2"}]}]}], ",", " ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m2u1", " ", 
            RowBox[{"vu", "/", 
             RowBox[{"\[Sqrt]", "2"}]}]}], " ", "-", " ", 
           RowBox[{"\[Lambda]", "  ", "A\[Lambda]1", " ", "vs", " ", 
            RowBox[{"vd", "/", "2"}]}]}], ")"}]}], "/", "f1"}], ",", " ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m2u2", " ", 
            RowBox[{"vu", "/", 
             RowBox[{"\[Sqrt]", "2"}]}]}], " ", "-", " ", 
           RowBox[{"\[Lambda]", " ", "A\[Lambda]2", " ", "vs", " ", 
            RowBox[{"vd", "/", "2"}]}]}], ")"}]}], "/", "f2"}], ",", " ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m2u3", " ", 
            RowBox[{"vu", "/", 
             RowBox[{"\[Sqrt]", "2"}]}]}], " ", "-", " ", 
           RowBox[{"\[Lambda]", " ", "A\[Lambda]3", " ", "vs", " ", 
            RowBox[{"vd", "/", "2"}]}]}], ")"}]}], "/", "f3"}]}], "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       RowBox[{
        RowBox[{"-", "\[Lambda]"}], " ", 
        RowBox[{"vu", "/", 
         RowBox[{"\[Sqrt]", "2"}]}]}], ",", " ", 
       RowBox[{
        RowBox[{"-", "\[Lambda]"}], " ", 
        RowBox[{"vd", "/", 
         RowBox[{"\[Sqrt]", "2"}]}]}], ",", " ", 
       RowBox[{
        RowBox[{"\[Sqrt]", "2"}], " ", "k", " ", "vs"}], ",", " ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m2s1", " ", 
            RowBox[{"vs", "/", 
             RowBox[{"\[Sqrt]", "2"}]}]}], " ", "-", " ", 
           RowBox[{"\[Lambda]", " ", "A\[Lambda]1", "  ", "vu", " ", 
            RowBox[{"vd", "/", "2"}]}], " ", "+", " ", 
           RowBox[{"k", "  ", "Ak1", " ", 
            RowBox[{
             SuperscriptBox["vs", "2"], "/", "2"}]}]}], ")"}]}], "/", "f1"}], 
       ",", " ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m2s2", " ", 
            RowBox[{"vs", "/", 
             RowBox[{"\[Sqrt]", "2"}]}]}], " ", "-", " ", 
           RowBox[{"\[Lambda]", "  ", "A\[Lambda]2", " ", "vu", " ", 
            RowBox[{"vd", "/", "2"}]}], " ", "+", " ", 
           RowBox[{"k", " ", "Ak2", " ", 
            RowBox[{
             SuperscriptBox["vs", "2"], "/", "2"}]}]}], ")"}]}], "/", "f2"}], 
       ",", " ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m2s3", " ", 
            RowBox[{"vs", "/", 
             RowBox[{"\[Sqrt]", "2"}]}]}], " ", "-", " ", 
           RowBox[{"\[Lambda]", "  ", "A\[Lambda]3", " ", "vu", " ", 
            RowBox[{"vd", "/", "2"}]}], " ", "+", " ", 
           RowBox[{"k", " ", "Ak3", " ", 
            RowBox[{
             SuperscriptBox["vs", "2"], "/", "2"}]}]}], ")"}]}], "/", 
        "f3"}]}], "}"}], ",", " ", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", " ", "MB1"}], " ", 
        RowBox[{"DY", "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Sqrt]", "2"}], " ", "f1"}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{"-", "MW1"}], " ", 
        RowBox[{"DT3", "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Sqrt]", "2"}], " ", "f1"}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m2d1", "  ", 
            RowBox[{"vd", "/", 
             RowBox[{"\[Sqrt]", "2"}]}]}], " ", "-", " ", 
           RowBox[{"\[Lambda]", "  ", "A\[Lambda]1", " ", "vs", " ", 
            RowBox[{"vu", "/", "2"}]}]}], ")"}]}], "/", "f1"}], " ", ",", " ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m2u1", " ", 
            RowBox[{"vu", "/", 
             RowBox[{"\[Sqrt]", "2"}]}]}], " ", "-", " ", 
           RowBox[{"\[Lambda]", " ", "A\[Lambda]1", " ", "vs", " ", 
            RowBox[{"vd", "/", "2"}]}]}], ")"}]}], "/", "f1"}], ",", " ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m2s1", " ", 
            RowBox[{"vs", "/", 
             RowBox[{"\[Sqrt]", "2"}]}]}], " ", "-", " ", 
           RowBox[{"\[Lambda]", " ", "A\[Lambda]1", " ", "vu", " ", 
            RowBox[{"vd", "/", "2"}]}], " ", "+", " ", 
           RowBox[{"k", " ", "Ak1", " ", 
            RowBox[{
             SuperscriptBox["vs", "2"], "/", "2"}]}]}], ")"}]}], "/", "f1"}], 
       " ", ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"f2", " ", "Mgld12"}], " ", "+", " ", 
           RowBox[{"f3", " ", "Mgld13"}]}], ")"}]}], "/", "f1"}], ",", " ", 
       "Mgld12", ",", " ", "Mgld13"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "MB2"}], " ", 
        RowBox[{"DY", "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Sqrt]", "2"}], " ", "f2"}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{"-", "MW2"}], " ", 
        RowBox[{"DT3", "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Sqrt]", "2"}], " ", "f2"}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m2d2", " ", 
            RowBox[{"vd", "/", 
             RowBox[{"\[Sqrt]", "2"}]}]}], " ", "-", " ", 
           RowBox[{"\[Lambda]", "  ", "A\[Lambda]2", " ", "vs", " ", 
            RowBox[{"vu", "/", "2"}]}]}], ")"}]}], "/", "f2"}], " ", ",", " ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m2u2", " ", 
            RowBox[{"vu", "/", 
             RowBox[{"\[Sqrt]", "2"}]}]}], " ", "-", " ", 
           RowBox[{"\[Lambda]", " ", "A\[Lambda]2", " ", "vs", " ", 
            RowBox[{"vd", "/", "2"}]}]}], ")"}]}], "/", "f2"}], ",", " ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m2s2", " ", 
            RowBox[{"vs", "/", 
             RowBox[{"\[Sqrt]", "2"}]}]}], " ", "-", " ", 
           RowBox[{"\[Lambda]", " ", "A\[Lambda]2", " ", "vu", " ", 
            RowBox[{"vd", "/", "2"}]}], " ", "+", " ", 
           RowBox[{"k", " ", "Ak2", " ", 
            RowBox[{
             SuperscriptBox["vs", "2"], "/", "2"}]}]}], ")"}]}], "/", "f2"}], 
       " ", ",", "\[IndentingNewLine]", "Mgld12", ",", " ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"f1", " ", "Mgld12"}], " ", "+", " ", 
           RowBox[{"f3", " ", "Mgld23"}]}], ")"}]}], "/", "f2"}], ",", " ", 
       "Mgld23"}], "}"}], ",", " ", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "MB3"}], " ", 
        RowBox[{"DY", "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Sqrt]", "2"}], " ", "f3"}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{"-", "MW3"}], " ", 
        RowBox[{"DT3", "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Sqrt]", "2"}], " ", "f3"}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m2d3", " ", 
            RowBox[{"vd", "/", 
             RowBox[{"\[Sqrt]", "2"}]}]}], " ", "-", " ", 
           RowBox[{"\[Lambda]", "  ", "A\[Lambda]3", " ", "vs", " ", 
            RowBox[{"vu", "/", "2"}]}]}], ")"}]}], "/", "f3"}], " ", ",", " ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m2u3", " ", 
            RowBox[{"vu", "/", 
             RowBox[{"\[Sqrt]", "2"}]}]}], " ", "-", 
           RowBox[{"\[Lambda]", " ", "A\[Lambda]3", " ", "vs", " ", 
            RowBox[{"vd", "/", "2"}]}]}], ")"}]}], "/", "f3"}], ",", " ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m2s3", " ", 
            RowBox[{"vs", "/", 
             RowBox[{"\[Sqrt]", "2"}]}]}], " ", "-", " ", 
           RowBox[{"\[Lambda]", " ", "A\[Lambda]3", " ", "vu", " ", 
            RowBox[{"vd", "/", "2"}]}], " ", "+", " ", 
           RowBox[{"k", " ", "Ak3", " ", 
            RowBox[{
             SuperscriptBox["vs", "2"], "/", "2"}]}]}], ")"}]}], "/", "f3"}], 
       " ", ",", " ", "Mgld13", ",", " ", "Mgld23", ",", " ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"f1", " ", "Mgld13"}], "+", 
           RowBox[{"f2", " ", "Mgld23"}]}], ")"}]}], "/", "f3"}]}], "}"}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.575277132625*^9, 3.57527714571875*^9}, {
   3.575277311421875*^9, 3.57527736209375*^9}, {3.5752775224375*^9, 
   3.575277592734375*^9}, {3.5752776684375*^9, 3.5752777060625*^9}, 
   3.575277750265625*^9, {3.575277803390625*^9, 3.57527791621875*^9}, {
   3.5752780689375*^9, 3.575278264484375*^9}, {3.575278314359375*^9, 
   3.57527850334375*^9}, {3.575278668078125*^9, 3.575278790625*^9}, 
   3.575279135578125*^9, {3.575279365890625*^9, 3.57527939409375*^9}, {
   3.575280808828125*^9, 3.5752808305625*^9}, {3.5752808835625*^9, 
   3.575280925296875*^9}, {3.57528129528125*^9, 3.5752813020625*^9}, {
   3.575281340015625*^9, 3.57528151040625*^9}, {3.575282458453125*^9, 
   3.575282464734375*^9}, {3.575282502765625*^9, 3.57528255175*^9}, {
   3.5752865158125*^9, 3.575286517203125*^9}, {3.575344770890625*^9, 
   3.57534477190625*^9}, {3.57534480559375*^9, 3.575344853140625*^9}, {
   3.57534490553125*^9, 3.575344907515625*^9}, {3.5753449410625*^9, 
   3.575344987640625*^9}, {3.57534568446875*^9, 3.575345689015625*^9}, {
   3.575345889421875*^9, 3.57534589009375*^9}, 3.5753459378125*^9, {
   3.575346182890625*^9, 3.5753462145625*^9}, {3.734933823066863*^9, 
   3.734933834327507*^9}, {3.734933916153187*^9, 3.734934005127276*^9}, {
   3.7349351514768434`*^9, 3.7349352555007935`*^9}, {3.73493528603854*^9, 
   3.734935411110694*^9}, {3.734935546510438*^9, 3.734935677477929*^9}, {
   3.7349358155768275`*^9, 3.7349359580699778`*^9}, {3.734936270224832*^9, 
   3.7349363807991567`*^9}, {3.7349364522942457`*^9, 
   3.7349364770416613`*^9}, {3.734936530918743*^9, 3.734936544550523*^9}, 
   3.734936586310911*^9, {3.734936622920005*^9, 3.7349366831454496`*^9}, {
   3.7349367378285775`*^9, 3.7349367860773373`*^9}, {3.73493685029401*^9, 
   3.7349370218118205`*^9}, {3.7349370723267097`*^9, 
   3.7349372471417084`*^9}, {3.734937316261662*^9, 3.7349373179097567`*^9}, 
   3.734937553354223*^9, {3.734937680006467*^9, 3.7349376822185936`*^9}, {
   3.734946474161264*^9, 3.7349465058137197`*^9}, {3.7349472798256793`*^9, 
   3.7349472822124834`*^9}, {3.735286990361416*^9, 3.735287004286515*^9}, {
   3.748858647035638*^9, 3.7488586517536497`*^9}, 3.748858706593396*^9, {
   3.748858771758412*^9, 3.748858773062525*^9}, {3.748938093049459*^9, 
   3.748938175907318*^9}, {3.748947831521737*^9, 3.748947837589957*^9}, {
   3.748947887687274*^9, 3.748947964637171*^9}, {3.748948076987994*^9, 
   3.748948164435141*^9}, {3.7489500794382153`*^9, 3.748950080453842*^9}, {
   3.7489503094535913`*^9, 3.748950371194866*^9}, {3.748950411826496*^9, 
   3.7489504389089813`*^9}, {3.7490966124489927`*^9, 
   3.7490966200864296`*^9}, {3.74909932923211*^9, 3.749099329653311*^9}, {
   3.749099398121831*^9, 3.7490994094942513`*^9}, {3.749099444188712*^9, 
   3.7490996244626284`*^9}, {3.7490997131955843`*^9, 
   3.7490997576088624`*^9}, {3.7490997972485323`*^9, 
   3.7490998189637704`*^9}, {3.749099880381078*^9, 3.7491000346341496`*^9}, {
   3.7491000671914062`*^9, 3.7491001047094717`*^9}, {3.749100546533448*^9, 
   3.74910076401343*^9}, {3.74910083822276*^9, 3.749100918001301*^9}, {
   3.7491009519313602`*^9, 3.7491010910524044`*^9}, {3.7491011280868697`*^9, 
   3.7491013119643927`*^9}, 3.749101513533347*^9, {3.7491017965178432`*^9, 
   3.7491018223826895`*^9}, 3.749102038692669*^9, {3.7491021486884623`*^9, 
   3.7491021773145123`*^9}, {3.749219689650023*^9, 3.7492197123683224`*^9}, {
   3.749224940863375*^9, 3.7492249423424597`*^9}, {3.7836877243164454`*^9, 
   3.7836877352167253`*^9}, {3.783687775426422*^9, 3.783687967364438*^9}, {
   3.783688002490675*^9, 3.783688247124096*^9}, {3.783688814536375*^9, 
   3.783688830297658*^9}, {3.783688907520184*^9, 3.7836890289205093`*^9}, {
   3.783689095427272*^9, 3.783689096163522*^9}, {3.783689284073288*^9, 
   3.783689435979027*^9}, {3.7837709378686333`*^9, 3.78377113711798*^9}, {
   3.7838368876706142`*^9, 3.783836889731988*^9}, 3.783849907873505*^9, {
   3.783923840468293*^9, 3.7839238450722847`*^9}, {3.7839352401300173`*^9, 
   3.783935264362409*^9}, {3.78393576223427*^9, 3.7839357646817503`*^9}, {
   3.785146357211075*^9, 3.785146358728594*^9}},
 CellLabel->"In[36]:=",ExpressionUUID->"0ea42274-238b-4ead-8550-ff50c2f3c92d"]
}, Closed]],

Cell[CellGroupData[{

Cell["Solutions to tadpole, SM definitions, D terms", "Subsection",
 CellChangeTimes->{{3.7350198558315334`*^9, 3.7350198642087483`*^9}, {
   3.74922410593462*^9, 3.749224119118374*^9}, {3.749226844714269*^9, 
   3.7492268463233614`*^9}, 3.749226964388114*^9, 3.7839252428406553`*^9, {
   3.783935296557576*^9, 
   3.7839353032531157`*^9}},ExpressionUUID->"4c72a7dc-4657-43f2-b831-\
3067981ed517"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"c\[Theta]", " ", "=", " ", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"1", "-", 
       SuperscriptBox["s\[Theta]", "2"]}], "]"}]}], ";"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"g1", "=", " ", 
     RowBox[{"2", " ", "s\[Theta]", " ", 
      RowBox[{"mz", "/", "v"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"g2", "=", " ", 
     RowBox[{"2", " ", "c\[Theta]", " ", 
      RowBox[{"mz", "/", "v"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"mz", " ", "=", " ", 
      RowBox[{"mw", "/", "c\[Theta]"}]}], ";"}], "  ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"sin\[Beta]", "=", " ", 
     RowBox[{"tan\[Beta]", "/", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"1", "+", 
        SuperscriptBox["tan\[Beta]", "2"]}], "]"}]}]}], ";"}], "  ", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"cos\[Beta]", "=", " ", 
     RowBox[{"1", "/", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"1", "+", 
        SuperscriptBox["tan\[Beta]", "2"]}], "]"}]}]}], ";"}], "  ", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"sin2\[Beta]", " ", "=", " ", 
     RowBox[{"2", " ", 
      RowBox[{"tan\[Beta]", "/", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox["tan\[Beta]", "2"]}], ")"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"cos2\[Beta]", " ", "=", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        SuperscriptBox["tan\[Beta]", "2"]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox["tan\[Beta]", "2"]}], ")"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vd", " ", "=", " ", 
     RowBox[{"v", " ", "cos\[Beta]"}]}], ";"}], "  ", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vu", " ", "=", " ", 
     RowBox[{"v", " ", "sin\[Beta]"}]}], ";"}], "  ", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"m2d", " ", "=", "  ", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Lambda]"}], " ", "A\[Lambda]", " ", "vu", " ", 
          RowBox[{"vs", "/", 
           RowBox[{"\[Sqrt]", "2"}]}]}], " ", "+", " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["g1", "2"], "+", 
            SuperscriptBox["g2", "2"]}], ")"}], "vd", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["vd", "2"], "-", 
             SuperscriptBox["vu", "2"]}], ")"}], "/", "8"}]}], " ", "+", " ", 
         RowBox[{
          SuperscriptBox["\[Lambda]", "2"], "vd", " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["vu", "2"], "+", 
             SuperscriptBox["vs", "2"]}], ")"}], "/", "2"}]}], " ", "-", 
         RowBox[{"\[Lambda]", " ", "k", " ", "vu", " ", 
          RowBox[{
           SuperscriptBox["vs", "2"], "/", "2"}]}]}], ")"}]}], "/", "vd"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"m2u", " ", "=", " ", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Lambda]"}], " ", "A\[Lambda]", " ", "vd", " ", 
          RowBox[{"vs", "/", 
           RowBox[{"\[Sqrt]", "2"}]}]}], " ", "-", " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["g1", "2"], "+", 
            SuperscriptBox["g2", "2"]}], ")"}], "vu", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["vd", "2"], "-", 
             SuperscriptBox["vu", "2"]}], ")"}], "/", "8"}]}], " ", "+", " ", 
         RowBox[{
          SuperscriptBox["\[Lambda]", "2"], "vu", " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["vd", "2"], "+", 
             SuperscriptBox["vs", "2"]}], ")"}], "/", "2"}]}], " ", "-", 
         RowBox[{"\[Lambda]", " ", "k", " ", "vd", " ", 
          RowBox[{
           SuperscriptBox["vs", "2"], "/", "2"}]}]}], ")"}]}], "/", "vu"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"m2s", " ", "=", "  ", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[Lambda]"}], " ", "A\[Lambda]", " ", "vd", " ", 
          RowBox[{"vu", "/", 
           RowBox[{"\[Sqrt]", "2"}]}]}], " ", "+", " ", 
         RowBox[{"k", " ", "Ak", " ", 
          RowBox[{
           SuperscriptBox["vs", "2"], "/", 
           RowBox[{"\[Sqrt]", "2"}]}]}], " ", "+", " ", 
         RowBox[{
          SuperscriptBox["\[Lambda]", "2"], "vs", " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["vd", "2"], "+", 
             SuperscriptBox["vu", "2"]}], ")"}], "/", "2"}]}], " ", "+", " ", 
         RowBox[{
          SuperscriptBox["k", 
           RowBox[{"2", " "}]], 
          SuperscriptBox["vs", "3"]}], " ", "-", 
         RowBox[{"\[Lambda]", " ", "k", " ", "vd", " ", "vu", " ", "vs"}]}], 
        ")"}]}], "/", "vs"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"DY", "=", 
     RowBox[{
      RowBox[{"-", "g1"}], " ", 
      SuperscriptBox["v", "2"], " ", 
      RowBox[{"cos2\[Beta]", "/", "4"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"DT3", "=", 
     RowBox[{
      RowBox[{"+", "g2"}], " ", 
      SuperscriptBox["v", "2"], " ", 
      RowBox[{"cos2\[Beta]", "/", "4"}]}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.7349504048364058`*^9, 3.734950429616823*^9}, {
   3.7353213517595377`*^9, 3.7353213622895565`*^9}, {3.7492192667648354`*^9, 
   3.749219296529538*^9}, {3.7492193535748005`*^9, 3.7492193859236507`*^9}, {
   3.7839353067825937`*^9, 3.78393531611756*^9}, 3.785747664764317*^9, 
   3.7857477025273247`*^9},
 CellLabel->"In[37]:=",ExpressionUUID->"5b321657-b1df-49cb-81b5-bf1b860f9f78"]
}, Closed]],

Cell[CellGroupData[{

Cell["Fermionic benchmarks", "Subsection",
 CellChangeTimes->{{3.832303310255024*^9, 3.832303316941701*^9}, {
  3.832304061315693*^9, 
  3.83230406281894*^9}},ExpressionUUID->"a2ec0bbe-513b-4807-b40f-\
824ee8489a17"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MB1", " ", "=", " ", 
    RowBox[{"x1B", " ", "MB"}]}], ";", " ", 
   RowBox[{"MB2", " ", "=", " ", 
    RowBox[{"x2B", " ", "MB"}]}], ";", " ", 
   RowBox[{"MB3", " ", "=", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", "x1B", "-", "x2B"}], ")"}], " ", "MB"}]}], ";"}], 
  "  "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MW1", " ", "=", " ", 
    RowBox[{"x1W", " ", "MW"}]}], ";", " ", 
   RowBox[{"MW2", " ", "=", " ", 
    RowBox[{"x2W", " ", "MW"}]}], ";", " ", 
   RowBox[{"MW3", " ", "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", "x1W", "-", "x2W"}], ")"}], "MW"}]}], ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m2u1", " ", "=", " ", 
   RowBox[{"x1u", " ", "m2u"}]}], ";", 
  RowBox[{"m2u2", " ", "=", " ", 
   RowBox[{"x2u", " ", "m2u"}]}], ";", 
  RowBox[{"m2u3", " ", "=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", "x1u", "-", "x2u"}], ")"}], " ", "m2u"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m2d1", " ", "=", " ", 
   RowBox[{"x1d", " ", "m2d"}]}], ";", 
  RowBox[{"m2d2", " ", "=", " ", 
   RowBox[{"x2d", " ", "m2d"}]}], ";", 
  RowBox[{"m2d3", " ", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", "x1d", "-", "x2d"}], ")"}], " ", "m2d"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m2s1", " ", "=", " ", 
   RowBox[{"x1s", " ", "m2s"}]}], ";", 
  RowBox[{"m2s2", " ", "=", " ", 
   RowBox[{"x2s", " ", "m2s"}]}], ";", 
  RowBox[{"m2s3", " ", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", "x1s", "-", "x2s"}], ")"}], " ", "m2s"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"A\[Lambda]1", " ", "=", " ", 
   RowBox[{"x1A\[Lambda]", " ", "A\[Lambda]"}]}], ";", " ", 
  RowBox[{"A\[Lambda]2", " ", "=", " ", 
   RowBox[{"x2A\[Lambda]", " ", "A\[Lambda]"}]}], ";", " ", 
  RowBox[{"A\[Lambda]3", " ", "=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", "x1A\[Lambda]", "-", "x2A\[Lambda]"}], ")"}], " ", 
    "A\[Lambda]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ak1", " ", "=", 
   RowBox[{"x1Ak", " ", "Ak"}]}], ";", " ", 
  RowBox[{"Ak2", " ", "=", " ", 
   RowBox[{"x2Ak", " ", "Ak"}]}], ";", " ", 
  RowBox[{"Ak3", " ", "=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", "x1Ak", "-", "x2Ak"}], ")"}], " ", "Ak"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Mgld12", " ", "=", " ", "Mgld"}], ";", " ", 
    RowBox[{"Mgld13", " ", "=", " ", "Mgld"}], ";", " ", 
    RowBox[{"Mgld23", " ", "=", " ", "Mgld"}], ";"}], "*)"}]}]}], "Input",
 CellChangeTimes->{
  3.749224966562845*^9, {3.778409890667272*^9, 3.7784099106448*^9}, {
   3.7836896663422937`*^9, 3.783689668365823*^9}, {3.783689713852518*^9, 
   3.783689741091867*^9}, {3.7837720473380747`*^9, 3.783772047471431*^9}, {
   3.783836487036401*^9, 3.783836553253035*^9}, {3.783836604950287*^9, 
   3.783836756044742*^9}, {3.783836840142682*^9, 3.783836844714291*^9}, {
   3.783836906121024*^9, 3.783836984559626*^9}, {3.78392321266123*^9, 
   3.7839232424052687`*^9}, {3.7839353222538147`*^9, 3.783935323692923*^9}, {
   3.7848972361258917`*^9, 3.784897238133054*^9}, {3.8072608936564407`*^9, 
   3.807260961489072*^9}, {3.807260998751151*^9, 3.8072610533670177`*^9}, {
   3.807271326152935*^9, 3.807271348544035*^9}, {3.807272279863516*^9, 
   3.807272281327333*^9}, {3.807272455896783*^9, 3.807272465631959*^9}, 
   3.807433339941772*^9, {3.807435615011046*^9, 3.807435616995009*^9}, {
   3.8117867118182554`*^9, 3.811786875364979*^9}, 3.829714194447772*^9, {
   3.830246899123185*^9, 3.830246900527231*^9}, 3.830850932359281*^9, 
   3.8323041071257153`*^9},
 CellLabel->"In[50]:=",ExpressionUUID->"4e2e97b2-d769-46f6-b2dd-d7615ba03ece"],

Cell["fix number os Goldstini sector", "Text",
 CellChangeTimes->{{3.81167206274164*^9, 
  3.811672070703623*^9}},ExpressionUUID->"853ac518-3050-46ba-89c3-\
d0062cde6c27"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ngld", "=", "3"}], ";"}]], "Input",
 CellChangeTimes->{{3.8116720729089117`*^9, 3.811672075652145*^9}, {
  3.8116903659142857`*^9, 3.8116903931883593`*^9}, {3.811693394343398*^9, 
  3.811693394433612*^9}, {3.8117323609488688`*^9, 3.811732361023999*^9}},
 CellLabel->"In[57]:=",ExpressionUUID->"3c5c64c3-48e1-426a-94c0-07dbc31e74a8"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Mgld12val", "=", " ", "0.9"}], ";", 
  RowBox[{"Mgld13val", "=", "0.85"}], ";", 
  RowBox[{"Mgld23val", "=", " ", "0.9"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fmax", " ", "=", " ", "2500000000."}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f2val", "=", 
   RowBox[{"0.02", "*", "fmax"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f3val", "=", 
   RowBox[{"0.01", "*", "fmax"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"x1Wval", "=", "1."}], ";", 
  RowBox[{"x2Wval", "=", "0."}], ";"}]}], "Input",
 CellChangeTimes->{{3.832304135901318*^9, 3.832304151340151*^9}, {
  3.8323062670822372`*^9, 3.832306284856999*^9}},
 CellLabel->"In[58]:=",ExpressionUUID->"8992a82a-ffda-4a11-9542-0aaee32bcb0d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PreCheck", "[", "btest_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"massneunum", ",", "Nmix", ",", "Mneu", ",", "masscharnum"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"massneunum", "=", 
      RowBox[{"massneu3", "/.", "btest"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Nmix", "=", 
      RowBox[{
       RowBox[{"Reverse", "[", 
        RowBox[{
         RowBox[{"Eigensystem", "[", "massneunum", "]"}], 
         "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "]"}], "//", 
       "Chop"}]}], " ", ";", "\[IndentingNewLine]", 
     RowBox[{"Mneu", "=", 
      RowBox[{
       RowBox[{"Reverse", "[", 
        RowBox[{
         RowBox[{"Eigensystem", "[", "massneunum", "]"}], 
         "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], "]"}], "//", 
       "Chop"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"\[CapitalGamma]", "[", 
       RowBox[{"i_", ",", " ", "j_"}], "]"}], ":=", " ", 
      RowBox[{"0", "/;", " ", 
       RowBox[{"i", "\[LessEqual]", " ", "j"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"\[CapitalGamma]", "[", 
       RowBox[{"i_", ",", " ", "j_"}], "]"}], ":=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", "\[IndentingNewLine]", "  ", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"MB1", " ", 
                RowBox[{"c\[Theta]", "/", "f1"}]}], ")"}], 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"i", ",", "1"}], "\[RightDoubleBracket]"}], 
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"j", ",", "6"}], "\[RightDoubleBracket]"}]}], " ", 
                "-", " ", 
                RowBox[{
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"j", ",", "1"}], "\[RightDoubleBracket]"}], 
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"i", ",", "6"}], "\[RightDoubleBracket]"}]}]}], 
               ")"}]}], "+", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"MB2", " ", 
                RowBox[{"c\[Theta]", "/", "f2"}]}], ")"}], 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"i", ",", "1"}], "\[RightDoubleBracket]"}], 
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"j", ",", "7"}], "\[RightDoubleBracket]"}]}], " ", 
                "-", " ", 
                RowBox[{
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"j", ",", "1"}], "\[RightDoubleBracket]"}], 
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"i", ",", "7"}], "\[RightDoubleBracket]"}]}]}], 
               ")"}]}], "+", " ", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"MB3", " ", 
                RowBox[{"c\[Theta]", "/", "f3"}]}], ")"}], 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"i", ",", "1"}], "\[RightDoubleBracket]"}], 
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"j", ",", "8"}], "\[RightDoubleBracket]"}]}], " ", 
                "-", " ", 
                RowBox[{
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"j", ",", "1"}], "\[RightDoubleBracket]"}], 
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"i", ",", "8"}], "\[RightDoubleBracket]"}]}]}], 
               ")"}]}], "+", " ", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"MW1", " ", 
                RowBox[{"s\[Theta]", "/", "f1"}]}], ")"}], 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"i", ",", "2"}], "\[RightDoubleBracket]"}], 
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"j", ",", "6"}], "\[RightDoubleBracket]"}]}], " ", 
                "-", " ", 
                RowBox[{
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"j", ",", "2"}], "\[RightDoubleBracket]"}], 
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"i", ",", "6"}], "\[RightDoubleBracket]"}]}]}], 
               ")"}]}], "+", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"MW2", " ", 
                RowBox[{"s\[Theta]", "/", "f2"}]}], ")"}], 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"i", ",", "2"}], "\[RightDoubleBracket]"}], 
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"j", ",", "7"}], "\[RightDoubleBracket]"}]}], " ", 
                "-", " ", 
                RowBox[{
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"j", ",", "2"}], "\[RightDoubleBracket]"}], 
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"i", ",", "7"}], "\[RightDoubleBracket]"}]}]}], 
               ")"}]}], "+", " ", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"MW3", " ", 
                RowBox[{"s\[Theta]", "/", "f3"}]}], ")"}], 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"i", ",", "2"}], "\[RightDoubleBracket]"}], 
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"j", ",", "8"}], "\[RightDoubleBracket]"}]}], " ", 
                "-", " ", 
                RowBox[{
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"j", ",", "2"}], "\[RightDoubleBracket]"}], 
                 RowBox[{"Nmix", "\[LeftDoubleBracket]", 
                  RowBox[{"i", ",", "8"}], "\[RightDoubleBracket]"}]}]}], 
               ")"}]}]}], "\[IndentingNewLine]", ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"Abs", "[", 
            RowBox[{
            "Mneu", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], 
            "]"}], "3"], " ", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "-", 
              RowBox[{
               SuperscriptBox[
                RowBox[{
                "Mneu", "\[LeftDoubleBracket]", "j", 
                 "\[RightDoubleBracket]"}], "2"], "/", 
               SuperscriptBox[
                RowBox[{
                "Mneu", "\[LeftDoubleBracket]", "i", 
                 "\[RightDoubleBracket]"}], "2"]}]}], ")"}], "3"], "/", 
           RowBox[{"(", 
            RowBox[{"16", " ", "\[Pi]"}], " ", ")"}]}]}], "/.", "btest"}], 
        ")"}], "/;", " ", 
       RowBox[{"i", ">", " ", "j"}]}]}], ";", " ", 
     RowBox[{"(*", " ", 
      RowBox[{"i", "\[Rule]", " ", 
       RowBox[{"j", "+", "\[Gamma]"}]}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(", " ", 
      RowBox[{
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"Nmix", "\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "6"}], "\[RightDoubleBracket]"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"Nmix", "\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "7"}], "\[RightDoubleBracket]"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"Nmix", "\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "8"}], "\[RightDoubleBracket]"}], "2"]}], ">", 
        "0.9"}], "&&", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"Nmix", "\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "6"}], "\[RightDoubleBracket]"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"Nmix", "\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "7"}], "\[RightDoubleBracket]"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"Nmix", "\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "8"}], "\[RightDoubleBracket]"}], "2"]}], ">", 
        "0.9"}], "&&", "  ", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"Nmix", "\[LeftDoubleBracket]", 
           RowBox[{"3", ",", "6"}], "\[RightDoubleBracket]"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"Nmix", "\[LeftDoubleBracket]", 
           RowBox[{"3", ",", "7"}], "\[RightDoubleBracket]"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"Nmix", "\[LeftDoubleBracket]", 
           RowBox[{"3", ",", "8"}], "\[RightDoubleBracket]"}], "2"]}], ">", 
        "0.9"}], "&&", "\[IndentingNewLine]", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"Nmix", "\[LeftDoubleBracket]", 
          RowBox[{"4", ",", "1"}], "\[RightDoubleBracket]"}], "2"], ">", 
        "0.8"}], "&&", "\[IndentingNewLine]", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"Nmix", "\[LeftDoubleBracket]", 
          RowBox[{"5", ",", "2"}], "\[RightDoubleBracket]"}], "2"], ">", 
        "0.8"}], "&&", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"\[CapitalGamma]", "[", 
         RowBox[{"4", ",", "3"}], "]"}], ">", 
        SuperscriptBox["10", 
         RowBox[{"-", "12"}]]}], " ", "&&", 
       RowBox[{
        RowBox[{"\[CapitalGamma]", "[", 
         RowBox[{"3", ",", "2"}], "]"}], ">", 
        SuperscriptBox["10", 
         RowBox[{"-", "12"}]]}], " ", "&&", 
       RowBox[{
        RowBox[{"\[CapitalGamma]", "[", 
         RowBox[{"4", ",", "3"}], "]"}], ">", 
        RowBox[{"\[CapitalGamma]", "[", 
         RowBox[{"4", ",", "2"}], "]"}]}], " ", "&&", 
       RowBox[{
        RowBox[{"\[CapitalGamma]", "[", 
         RowBox[{"4", ",", "3"}], "]"}], ">", 
        RowBox[{"\[CapitalGamma]", "[", 
         RowBox[{"4", ",", "1"}], "]"}]}], " ", "&&", 
       RowBox[{
        RowBox[{"\[CapitalGamma]", "[", 
         RowBox[{"3", ",", "2"}], "]"}], ">", 
        RowBox[{"\[CapitalGamma]", "[", 
         RowBox[{"3", ",", "1"}], "]"}]}], " ", "\[IndentingNewLine]", "&&", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Abs", "[", 
          RowBox[{
          "Mneu", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
          "]"}], "-", 
         RowBox[{"Abs", "[", 
          RowBox[{
          "Mneu", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
          "]"}]}], ">", "30."}], "&&", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Abs", "[", 
          RowBox[{
          "Mneu", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}], 
          "]"}], "-", 
         RowBox[{"Abs", "[", 
          RowBox[{
          "Mneu", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
          "]"}]}], ">", "30."}], " ", "&&", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Abs", "[", 
         RowBox[{
         "Mneu", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
         "]"}], "<", "90."}]}], ")"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8323042306291437`*^9, 3.832304232037119*^9}, {
   3.8323042798062696`*^9, 3.832304325171441*^9}, {3.83230447278859*^9, 
   3.832304474590114*^9}, {3.832304839649218*^9, 3.832304857140143*^9}, {
   3.832305031205489*^9, 3.832305111166629*^9}, 3.832308144134637*^9, {
   3.83276087309301*^9, 3.832760879002118*^9}, {3.83277046832942*^9, 
   3.832770472258772*^9}, {3.8327720956650476`*^9, 3.832772099490424*^9}},
 CellLabel->"In[63]:=",ExpressionUUID->"7a17a464-7b39-4a93-b5f6-3f088b10f53d"]
}, Closed]],

Cell[CellGroupData[{

Cell["Initialize benchmark model ", "Chapter",
 CellChangeTimes->{{3.844872638746442*^9, 3.844872656932686*^9}, {
  3.8448729170098753`*^9, 
  3.844872924927618*^9}},ExpressionUUID->"9b77a7a1-b845-4871-8d7a-\
602f69881625"],

Cell["example:", "Text",
 CellChangeTimes->{{3.844873162890624*^9, 
  3.844873166303628*^9}},ExpressionUUID->"8519ace4-b67f-41c7-a916-\
a1e007d5fa67"],

Cell[BoxData[
 RowBox[{
  RowBox[{"bench", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"bosBM", "->", "1"}], ",", 
     RowBox[{"MB", "->", "202"}], ",", 
     RowBox[{"MW", "->", "1220"}], ",", 
     RowBox[{"x1B", "->", 
      RowBox[{"-", "0.965793622015723"}]}], ",", 
     RowBox[{"x2B", "->", 
      RowBox[{"-", "0.9761637658940838"}]}], ",", 
     RowBox[{"x1W", "->", "1."}], ",", 
     RowBox[{"x2W", "->", "0."}], ",", 
     RowBox[{"x1u", "->", "0.12232925611619017"}], ",", 
     RowBox[{"x2u", "->", "0.07546314995417536"}], ",", 
     RowBox[{"x1d", "->", "1.1441063544289243"}], ",", 
     RowBox[{"x2d", "->", 
      RowBox[{"-", "0.8147520932644774"}]}], ",", 
     RowBox[{"x1s", "->", "1.5533927917183785"}], ",", 
     RowBox[{"x2s", "->", 
      RowBox[{"-", "0.3175385561386115"}]}], ",", 
     RowBox[{"x1A\[Lambda]", "->", 
      RowBox[{"-", "0.4911551693297307"}]}], ",", 
     RowBox[{"x2A\[Lambda]", "->", "2.115030700783743"}], ",", 
     RowBox[{"x1Ak", "->", "2.050532545847604"}], ",", 
     RowBox[{"x2Ak", "->", "0.30944026097771626"}], ",", 
     RowBox[{"f1", "->", "2.5*^9"}], ",", 
     RowBox[{"f2", "->", "5.*^7"}], ",", 
     RowBox[{"f3", "->", "2.5*^7"}], ",", 
     RowBox[{"Mgld12", "->", "0.9"}], ",", 
     RowBox[{"Mgld13", "->", "0.85"}], ",", 
     RowBox[{"Mgld23", "->", "0.9"}], ",", 
     RowBox[{"\[Lambda]", "->", "1.1"}], ",", 
     RowBox[{"k", "->", "0.8349598869408863"}], ",", 
     RowBox[{"tan\[Beta]", "->", "1.5"}], ",", 
     RowBox[{"vs", "->", "1938.473039599675"}], ",", 
     RowBox[{"A\[Lambda]", "->", 
      RowBox[{"-", "829.1311903528058"}]}], ",", 
     RowBox[{"Ak", "->", 
      RowBox[{"-", "153.69190003497778"}]}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.84487266534396*^9, 3.844872666015122*^9}, {
  3.8448729832857323`*^9, 3.8448729990343122`*^9}},
 CellLabel->"In[64]:=",ExpressionUUID->"df3dfe28-e441-47bc-abe8-0d9190538788"],

Cell[CellGroupData[{

Cell["SM input parameters", "Subsection",
 CellChangeTimes->{{3.807868953047305*^9, 
  3.807869014541256*^9}},ExpressionUUID->"d6aa8f0e-71bf-4780-babf-\
e34d8b9b7f86"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Gf", "=", "1.1663787*^-5"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"v", "=", 
   RowBox[{"1", "/", 
    RowBox[{"Sqrt", "[", 
     RowBox[{
      RowBox[{"Sqrt", "[", "2", "]"}], " ", "Gf"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"mw", "=", "80.379"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"s\[Theta]", "=", 
   RowBox[{"Sqrt", "[", "0.23122", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"ee", "=", 
   RowBox[{"s\[Theta]", " ", "2", " ", 
    RowBox[{"mw", "/", "v"}]}]}], ";", 
  RowBox[{"aEWM1", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"ee", "^", "2"}], "/", 
      RowBox[{"(", 
       RowBox[{"4", " ", "\[Pi]"}], ")"}]}], ")"}], "^", 
    RowBox[{"-", "1"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.808217395775981*^9, 3.808217395777115*^9}},
 CellLabel->"In[65]:=",ExpressionUUID->"9859b545-a5c6-4b92-b34b-0d0a1630fae8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"c\[Theta]", "=", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["s\[Theta]", "2"]}]]}], ";", 
  RowBox[{"mz", "=", 
   RowBox[{"mw", "/", "c\[Theta]"}]}]}]], "Input",
 CellChangeTimes->{{3.8079363490944777`*^9, 3.807936352000559*^9}, {
  3.807936392008399*^9, 3.80793640977805*^9}},
 CellLabel->"In[70]:=",ExpressionUUID->"ff7d78b4-8570-4b33-84b4-8314e8123b15"],

Cell[BoxData["91.67302462643129`"], "Output",
 CellChangeTimes->{
  3.8079364159431477`*^9, 3.80794061236233*^9, 3.808033560486877*^9, 
   3.8081953768462048`*^9, 3.808197910578918*^9, 3.80820632364847*^9, 
   3.808207479950221*^9, 3.808207581375215*^9, 3.808216997042035*^9, 
   3.8082177247444687`*^9, 3.808217964039733*^9, 3.808220755180962*^9, 
   3.808466700238319*^9, 3.808468522088129*^9, 3.8084714276198063`*^9, 
   3.808472199527388*^9, 3.808472843382441*^9, 3.808473203255762*^9, 
   3.80848393935023*^9, 3.808541631408053*^9, 3.808543081924337*^9, 
   3.808555074189705*^9, 3.808581169658169*^9, 3.80862223650799*^9, 
   3.808625252666189*^9, 3.808632470117031*^9, 3.8086402403142557`*^9, 
   3.80870832426924*^9, 3.8087085477199793`*^9, 3.808731111914989*^9, 
   3.808731166110272*^9, 3.80873283126154*^9, 3.808794460636903*^9, 
   3.810810305699142*^9, 3.810810559546135*^9, 3.810893203717555*^9, 
   3.810893494912737*^9, 3.8116724918730516`*^9, {3.811673042806272*^9, 
   3.811673072188735*^9}, 3.811690416007689*^9, 3.81169206113354*^9, 
   3.8116923433466*^9, 3.811693083953903*^9, 3.811693422686946*^9, 
   3.81173236551805*^9, 3.811735958758544*^9, 3.811736912523164*^9, 
   3.8117383855169888`*^9, 3.811835499681093*^9, 3.811837534501687*^9, 
   3.8118407444176693`*^9, 3.81184083193143*^9, 3.8118409186963043`*^9, 
   3.8120826327134447`*^9, 3.812083843878824*^9, 3.8120845712781267`*^9, 
   3.812084806218539*^9, 3.812090847304943*^9, 3.8121825520766163`*^9, 
   3.81218436011705*^9, 3.812185427181826*^9, 3.812187408092806*^9, 
   3.812208533108169*^9, 3.812433971511466*^9, 3.812439362262558*^9, 
   3.8124465330273323`*^9, 3.8128171318894367`*^9, 3.8128691961990128`*^9, 
   3.812879518354464*^9, 3.812976695904935*^9, 3.812991819412406*^9, 
   3.812997821108831*^9, 3.8130355769901857`*^9, 3.813042032369679*^9, 
   3.8130468254405746`*^9, 3.81598283603594*^9, 3.8159886371872253`*^9, 
   3.815988936997439*^9, 3.815992057378202*^9, 3.820855410867395*^9, 
   3.8239262195911913`*^9, 3.823926485045657*^9, {3.8239404915009937`*^9, 
   3.823940520682592*^9}, 3.823940563521056*^9, 3.823940596994314*^9, 
   3.823940633423317*^9, 3.8239406690600843`*^9, 3.823940762136324*^9, 
   3.823945067597218*^9, 3.8239452075405903`*^9, 3.8239661972011747`*^9, 
   3.823966984329977*^9, 3.824101728303027*^9, 3.8241094744931917`*^9, 
   3.8241277818313*^9, 3.8241356414122*^9, 3.8241995707023697`*^9, 
   3.8272869748494463`*^9, 3.827288721197612*^9, 3.8272890963064327`*^9, 
   3.827289461930901*^9, 3.827289630035542*^9, 3.827289996631154*^9, 
   3.827290227846526*^9, 3.8272910318868847`*^9, 3.827291094473899*^9, 
   3.8272936047269382`*^9, 3.827294394087215*^9, 3.827294493114773*^9, 
   3.827476560776744*^9, 3.82841038063866*^9, 3.8310929603713093`*^9, 
   3.8311941912037077`*^9, 3.831196249850719*^9, 3.831196342100503*^9, 
   3.832307027314208*^9, 3.8323081821340647`*^9, 3.8323095378709917`*^9, 
   3.832760851821261*^9, 3.832768806545557*^9, 3.832769265113743*^9, 
   3.832770806198131*^9, 3.832772323475819*^9, 3.832772966598886*^9, 
   3.8328800160587*^9, 3.844874710723104*^9},
 CellLabel->"Out[70]=",ExpressionUUID->"00e9003a-331e-442e-8ce3-f0e2497fe6ab"]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Numeric part bosonic", "Title",
 CellChangeTimes->{{3.735019543581385*^9, 3.7350195455469885`*^9}, {
  3.735113072612387*^9, 3.7351130755451927`*^9}, {3.78377221589954*^9, 
  3.783772219370441*^9}},ExpressionUUID->"2714e2f1-a98b-4077-b4d1-\
ba9bf7454843"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Print", "[", "\"\<Bosonic part\>\"", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.808198730317404*^9, 3.808198744511964*^9}},
 CellLabel->"In[71]:=",ExpressionUUID->"b13fb1f4-d71a-4c91-9c01-cc9d703d4ede"],

Cell[BoxData["\<\"Bosonic part\"\>"], "Print",
 CellChangeTimes->{3.8082179701800623`*^9, 3.808536385517439*^9, 
  3.808625320544635*^9, 3.810893556438023*^9, 3.81167252359371*^9, 
  3.811840852142479*^9, 3.811840928122778*^9, 3.827291038230843*^9, 
  3.827291102737728*^9, 3.827294529250649*^9, 3.831093191274194*^9, 
  3.844874710739238*^9},
 CellLabel->
  "During evaluation of \
In[71]:=",ExpressionUUID->"bf015fb4-57a4-48d8-a4d1-0574cd530922"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Diagonalize etc...", "Subsection",
 CellChangeTimes->{{3.7839270211114073`*^9, 
  3.783927026773356*^9}},ExpressionUUID->"547708db-bc01-49d4-9783-\
126dd8a205a9"],

Cell["Neutral scalars", "Text",
 CellChangeTimes->{{3.7839467310369797`*^9, 3.783946739500659*^9}, 
   3.783948360601371*^9},ExpressionUUID->"fa24d4ee-2620-4135-a249-\
83d086a47687"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mass2Hnum", "=", 
   RowBox[{"mass2H", "/.", "bench"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.7838375227032003`*^9, 3.783837542422811*^9}, {
   3.783927050767124*^9, 3.7839270682098207`*^9}, {3.783927157193336*^9, 
   3.78392716603449*^9}, {3.783932474858472*^9, 3.783932479262889*^9}, 
   3.783946444834343*^9, {3.783946646194161*^9, 3.783946646285761*^9}, 
   3.7839482318881617`*^9, 3.785239289267825*^9},
 CellLabel->"In[72]:=",ExpressionUUID->"46caef3b-b107-47f1-a530-eb30c0d4bceb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mH", "=", 
  RowBox[{
   RowBox[{"Reverse", "[", 
    RowBox[{"Sqrt", "[", 
     RowBox[{
      RowBox[{"Eigensystem", "[", "mass2Hnum", "]"}], "\[LeftDoubleBracket]", 
      "1", "\[RightDoubleBracket]"}], "]"}], "]"}], "//", "Chop"}]}]], "Input",
 CellChangeTimes->{{3.78377266658185*^9, 3.783772730963071*^9}, {
   3.783837064474823*^9, 3.783837083125971*^9}, {3.783837131947834*^9, 
   3.783837156605651*^9}, {3.783837303958125*^9, 3.7838373176119556`*^9}, {
   3.7838374306479588`*^9, 3.783837438147977*^9}, {3.7838375532769413`*^9, 
   3.783837559290822*^9}, {3.783838427835779*^9, 3.7838384468993387`*^9}, {
   3.783847425375*^9, 3.783847465709817*^9}, 3.783848941870492*^9, 
   3.7838614807323027`*^9, {3.7839270726120157`*^9, 3.783927108084414*^9}, {
   3.783931974263118*^9, 3.7839319748343363`*^9}, 3.783946450026647*^9, 
   3.783946535514016*^9, {3.784005876125812*^9, 3.784005877958837*^9}},
 CellLabel->"In[73]:=",ExpressionUUID->"f39c1a72-b2da-4841-b7ac-8f095ffef269"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "109.409125801339`", ",", "1001.8059829768737`", ",", 
   "2253.268389484414`"}], "}"}]], "Output",
 CellChangeTimes->{{3.783927090287024*^9, 3.783927108692391*^9}, 
   3.783931976637229*^9, 3.7839358265500717`*^9, 3.783946451436121*^9, 
   3.783946537664875*^9, 3.7839466624375553`*^9, 3.783948256567935*^9, 
   3.784005988817033*^9, {3.784006267044347*^9, 3.784006289512656*^9}, 
   3.784007789298561*^9, 3.78401414962742*^9, 3.7840207617589197`*^9, 
   3.784021754941491*^9, 3.7840228942818604`*^9, 3.784023068774119*^9, 
   3.78402316389948*^9, {3.784023205522458*^9, 3.784023225133597*^9}, 
   3.784024160379634*^9, 3.784024280516543*^9, 3.784025401120775*^9, 
   3.784026914897276*^9, 3.784026994778954*^9, 3.784897252180469*^9, 
   3.784897656271208*^9, 3.784961729794547*^9, 3.784965674860018*^9, 
   3.7849672225194283`*^9, 3.784973009865307*^9, 3.784973233899353*^9, 
   3.78497404211201*^9, 3.7849746858770943`*^9, 3.784975056670895*^9, 
   3.784975127716124*^9, 3.784977162981247*^9, 3.7851433860500526`*^9, 
   3.785146569571034*^9, 3.785163432118146*^9, 3.785163811368519*^9, 
   3.785239479154299*^9, 3.785239581228035*^9, 3.7852424311562366`*^9, 
   3.785747871195612*^9, 3.785753957202051*^9, 3.787898615032185*^9, 
   3.788257193876255*^9, 3.807869449323945*^9, 3.807933842070766*^9, 
   3.8079406447852163`*^9, 3.808033656959038*^9, 3.808195424921019*^9, 
   3.808217084851927*^9, 3.808217970218916*^9, 3.808536385560451*^9, 
   3.808625320595229*^9, 3.810893556485651*^9, 3.811672523664583*^9, 
   3.811840852283839*^9, 3.811840928153969*^9, 3.827291038385848*^9, 
   3.827291102770879*^9, 3.827294529292523*^9, 3.831093191323286*^9, 
   3.844874710772641*^9},
 CellLabel->"Out[73]=",ExpressionUUID->"0e042405-0656-465a-bf27-3f6b62a4f070"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Hmix", "=", 
   RowBox[{
    RowBox[{"Reverse", "[", 
     RowBox[{
      RowBox[{"Eigensystem", "[", "mass2Hnum", "]"}], "\[LeftDoubleBracket]", 
      "2", "\[RightDoubleBracket]"}], "]"}], "//", "Chop"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.783847478923912*^9, 3.783847484383095*^9}, 
   3.783848946105035*^9, {3.7839271259961653`*^9, 3.7839271343813*^9}},
 CellLabel->"In[74]:=",ExpressionUUID->"f5ff67b4-7466-4dff-85c8-924a04a4f89e"],

Cell["Neutral pseudoscalars", "Text",
 CellChangeTimes->{{3.7839467517091417`*^9, 
  3.7839467591476383`*^9}},ExpressionUUID->"f7f8fbde-599a-4b0c-859f-\
8ab1428bab3a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mass2Anum", "=", 
   RowBox[{"mass2AwithGold", "/.", "bench"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.7838375227032003`*^9, 3.783837542422811*^9}, {
   3.783927050767124*^9, 3.7839270682098207`*^9}, {3.783927157193336*^9, 
   3.78392716603449*^9}, {3.7839319455890083`*^9, 3.783931948235108*^9}, {
   3.7839319967004147`*^9, 3.783931998229156*^9}, {3.78393248268934*^9, 
   3.783932486271343*^9}, {3.783946568646112*^9, 3.7839465688000793`*^9}, 
   3.7839482350417213`*^9, 3.785239309035623*^9},
 CellLabel->"In[75]:=",ExpressionUUID->"5593c61b-b08a-4c92-906e-042e3ca852fc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mA", "=", 
  RowBox[{
   RowBox[{"Reverse", "[", 
    RowBox[{"Sqrt", "[", 
     RowBox[{
      RowBox[{"Eigensystem", "[", "mass2Anum", "]"}], "\[LeftDoubleBracket]", 
      "1", "\[RightDoubleBracket]"}], "]"}], "]"}], "//", "Chop"}]}]], "Input",
 CellChangeTimes->{{3.78377266658185*^9, 3.783772730963071*^9}, {
   3.783837064474823*^9, 3.783837083125971*^9}, {3.783837131947834*^9, 
   3.783837156605651*^9}, {3.783837303958125*^9, 3.7838373176119556`*^9}, {
   3.7838374306479588`*^9, 3.783837438147977*^9}, {3.7838375532769413`*^9, 
   3.783837559290822*^9}, {3.783838427835779*^9, 3.7838384468993387`*^9}, {
   3.783847425375*^9, 3.783847465709817*^9}, 3.783848941870492*^9, 
   3.7838614807323027`*^9, {3.7839270726120157`*^9, 3.783927108084414*^9}, {
   3.7839319541903887`*^9, 3.7839319880743237`*^9}, {3.783932334783657*^9, 
   3.7839323453075647`*^9}, 3.783946833223572*^9},
 CellLabel->"In[76]:=",ExpressionUUID->"e3132b9d-c8d3-446f-8f2c-dd920e0aa0ad"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"0.`", "\[VeryThinSpace]", "+", 
    RowBox[{"0.0000152587890625`", " ", "\[ImaginaryI]"}]}], ",", 
   "399.99999999999994`", ",", "1199.9999999999998`"}], "}"}]], "Output",
 CellChangeTimes->{{3.783927090287024*^9, 3.783927108692391*^9}, {
   3.783931988660676*^9, 3.783932003741053*^9}, 3.783932346461084*^9, 
   3.783935826696677*^9, 3.783946684735545*^9, 3.783946833838895*^9, 
   3.783948256679103*^9, 3.784005988950893*^9, {3.7840062671460047`*^9, 
   3.7840062896062593`*^9}, 3.784007789417836*^9, 3.784014149703225*^9, 
   3.7840207618570147`*^9, 3.784021755118431*^9, 3.784022894350444*^9, 
   3.7840230688575974`*^9, 3.784023163958879*^9, {3.784023205587566*^9, 
   3.7840232252049522`*^9}, 3.7840241604883823`*^9, 3.784024280606691*^9, 
   3.784025401237434*^9, 3.784026914978366*^9, 3.784026994887892*^9, 
   3.784897252361706*^9, 3.7848976564953957`*^9, 3.7849617299096107`*^9, 
   3.784965674933024*^9, 3.784967222589941*^9, 3.78497300994206*^9, 
   3.784973233972877*^9, 3.7849740421795464`*^9, 3.784974685953071*^9, 
   3.784975056713476*^9, 3.784975127764926*^9, 3.7849771630294847`*^9, 
   3.7851433861084146`*^9, 3.785146569669683*^9, 3.785163432183043*^9, 
   3.785163811423193*^9, 3.785239479204458*^9, 3.785239581280323*^9, 
   3.785242431216441*^9, 3.7857478819555273`*^9, 3.785753957262177*^9, 
   3.787898615091413*^9, 3.7882571940090446`*^9, 3.807869733599873*^9, 
   3.807933842253296*^9, 3.807940655679472*^9, 3.808033657046113*^9, 
   3.8081954249845448`*^9, 3.808217092963684*^9, 3.808217970243572*^9, 
   3.808536385587682*^9, 3.808625320625389*^9, 3.81089355651088*^9, 
   3.81167252371038*^9, 3.811840852389243*^9, 3.8118409281808033`*^9, 
   3.8272910385460873`*^9, 3.827291102797744*^9, 3.8272945293213863`*^9, 
   3.831093191355393*^9, 3.844874710830742*^9},
 CellLabel->"Out[76]=",ExpressionUUID->"ce62d16a-908a-4dfc-8c96-63595e95a48d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Amix", "=", 
   RowBox[{
    RowBox[{"Reverse", "[", 
     RowBox[{
      RowBox[{"Eigensystem", "[", "mass2Anum", "]"}], "\[LeftDoubleBracket]", 
      "2", "\[RightDoubleBracket]"}], "]"}], "//", "Chop"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.783847478923912*^9, 3.783847484383095*^9}, 
   3.783848946105035*^9, {3.7839271259961653`*^9, 3.7839271343813*^9}, {
   3.78393203979464*^9, 3.783932043129283*^9}},
 CellLabel->"In[77]:=",ExpressionUUID->"3142175a-2583-425a-b905-41dc1e3d0f56"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MA2", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"Reverse", "[", 
     RowBox[{"Sort", "[", "mA", "]"}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "^", "2"}]}]], "Input",
 CellChangeTimes->{{3.7840059979185534`*^9, 3.784006071418459*^9}, {
  3.78400611050776*^9, 3.784006111849039*^9}},
 CellLabel->"In[78]:=",ExpressionUUID->"75ce99f5-3eb1-4593-bbde-0588bcef6523"],

Cell[BoxData["1.4399999999999995`*^6"], "Output",
 CellChangeTimes->{{3.784006034265905*^9, 3.7840060594375668`*^9}, 
   3.784006112370954*^9, {3.784006267241139*^9, 3.7840062896992483`*^9}, 
   3.7840077895133266`*^9, 3.784014149776722*^9, 3.784020761925138*^9, 
   3.784021755237997*^9, 3.784022894410965*^9, 3.784023068918647*^9, 
   3.784023164013352*^9, {3.784023205641721*^9, 3.784023225260507*^9}, 
   3.784024160590906*^9, 3.784024280673551*^9, 3.7840254013810043`*^9, 
   3.784026915052114*^9, 3.784026994994681*^9, 3.7848972526112556`*^9, 
   3.7848976566118107`*^9, 3.784961730002118*^9, 3.784965675000867*^9, 
   3.784967222657083*^9, 3.78497301000878*^9, 3.784973234042906*^9, 
   3.784974042247233*^9, 3.7849746860206327`*^9, 3.784975056749094*^9, 
   3.784975127807644*^9, 3.784977163071612*^9, 3.785143386156012*^9, 
   3.785146569757387*^9, 3.7851634322374*^9, 3.785163811484639*^9, 
   3.78523947924504*^9, 3.7852395813232803`*^9, 3.7852424312714167`*^9, 
   3.785747895935611*^9, 3.785753957311989*^9, 3.787898615140366*^9, 
   3.788257194102199*^9, 3.8078697482588263`*^9, 3.807933842347031*^9, 
   3.807940667667235*^9, 3.808033657122242*^9, 3.808195425039735*^9, 
   3.808217095762437*^9, 3.808217970268067*^9, 3.8085363856098833`*^9, 
   3.808625320652768*^9, 3.810893556532995*^9, 3.811840852486354*^9, 
   3.811840928201084*^9, 3.827291038627225*^9, 3.8272911028191223`*^9, 
   3.827294529341893*^9, 3.831093191377058*^9, 3.844874710851241*^9},
 CellLabel->"Out[78]=",ExpressionUUID->"c111743f-9434-43b5-95d0-69503aca2eb0"]
}, Open  ]],

Cell["Charged scalar", "Text",
 CellChangeTimes->{{3.7839467517091417`*^9, 
  3.783946780056902*^9}},ExpressionUUID->"07c01816-9f65-487d-8fc6-\
ff931469c896"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mass2Hpmnum", "=", 
   RowBox[{"mass2HpmwithGold", "/.", "bench"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.7838375227032003`*^9, 3.783837542422811*^9}, {
   3.783927050767124*^9, 3.7839270682098207`*^9}, {3.783927157193336*^9, 
   3.78392716603449*^9}, {3.7839319455890083`*^9, 3.783931948235108*^9}, {
   3.7839319967004147`*^9, 3.783931998229156*^9}, {3.78393248268934*^9, 
   3.783932486271343*^9}, {3.783946568646112*^9, 3.7839465688000793`*^9}, {
   3.7839467841641407`*^9, 3.7839467904334373`*^9}, 3.78394823598484*^9, 
   3.785239313187503*^9},
 CellLabel->"In[79]:=",ExpressionUUID->"61444ab4-72ce-4d95-b700-d8239c5741da"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mHpm", "=", 
  RowBox[{
   RowBox[{"Reverse", "[", 
    RowBox[{"Sqrt", "[", 
     RowBox[{
      RowBox[{"Eigensystem", "[", "mass2Hpmnum", "]"}], 
      "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], "]"}], "]"}], "//",
    "Chop"}]}]], "Input",
 CellChangeTimes->{{3.78377266658185*^9, 3.783772730963071*^9}, {
   3.783837064474823*^9, 3.783837083125971*^9}, {3.783837131947834*^9, 
   3.783837156605651*^9}, {3.783837303958125*^9, 3.7838373176119556`*^9}, {
   3.7838374306479588`*^9, 3.783837438147977*^9}, {3.7838375532769413`*^9, 
   3.783837559290822*^9}, {3.783838427835779*^9, 3.7838384468993387`*^9}, {
   3.783847425375*^9, 3.783847465709817*^9}, 3.783848941870492*^9, 
   3.7838614807323027`*^9, {3.7839270726120157`*^9, 3.783927108084414*^9}, {
   3.7839319541903887`*^9, 3.7839319880743237`*^9}, {3.783932334783657*^9, 
   3.7839323453075647`*^9}, {3.783946799186305*^9, 3.783946809563015*^9}, 
   3.783946840824868*^9},
 CellLabel->"In[80]:=",ExpressionUUID->"9ffe6c06-b8e5-494c-9ab7-2e5856aa051f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"0.`", "\[VeryThinSpace]", "+", 
    RowBox[{"5.3947966093944364`*^-6", " ", "\[ImaginaryI]"}]}], ",", 
   "1000.`"}], "}"}]], "Output",
 CellChangeTimes->{{3.783927090287024*^9, 3.783927108692391*^9}, {
   3.783931988660676*^9, 3.783932003741053*^9}, 3.783932346461084*^9, 
   3.783935826696677*^9, 3.783946684735545*^9, {3.783946812839032*^9, 
   3.783946841419012*^9}, 3.7839482567926483`*^9, 3.7840059890772743`*^9, {
   3.784006267285226*^9, 3.7840062897336893`*^9}, 3.784007789557621*^9, 
   3.784014149807629*^9, 3.7840207619571323`*^9, 3.784021755272958*^9, 
   3.784022894433897*^9, 3.784023068948051*^9, 3.7840231640341263`*^9, {
   3.784023205663015*^9, 3.784023225284217*^9}, 3.784024160630157*^9, 
   3.784024280701291*^9, 3.7840254014391823`*^9, 3.784026915081902*^9, 
   3.784026995039566*^9, 3.784897252673575*^9, 3.784897656667098*^9, 
   3.7849617300481033`*^9, 3.784965675029814*^9, 3.784967222681739*^9, 
   3.784973010038046*^9, 3.784973234068598*^9, 3.784974042273797*^9, 
   3.7849746860483828`*^9, 3.784975056765958*^9, 3.784975127824651*^9, 
   3.784977163089374*^9, 3.785143386179574*^9, 3.78514656978414*^9, 
   3.7851634322623987`*^9, 3.785163811506424*^9, 3.785239479264688*^9, 
   3.785239581343046*^9, 3.785242431292882*^9, 3.7857479015924664`*^9, 
   3.785753957334553*^9, 3.78789861516118*^9, 3.788257194142585*^9, 
   3.807869760170186*^9, 3.8079338423807983`*^9, 3.807940670783289*^9, 
   3.808033657155555*^9, 3.808195425062998*^9, 3.808217101035149*^9, 
   3.8082179702899113`*^9, 3.808536385632345*^9, 3.808625320678527*^9, 
   3.810893556554802*^9, 3.811840852542745*^9, 3.811840928220503*^9, 
   3.827291038690693*^9, 3.827291102839459*^9, 3.827294529364468*^9, 
   3.831093191405061*^9, 3.844874710870397*^9},
 CellLabel->"Out[80]=",ExpressionUUID->"6481113b-c7fd-4a09-a484-0adc89570879"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Hpmmix", "=", 
   RowBox[{
    RowBox[{"Reverse", "[", 
     RowBox[{
      RowBox[{"Eigensystem", "[", "mass2Hpmnum", "]"}], 
      "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "]"}], "//", 
    "Chop"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.783847478923912*^9, 3.783847484383095*^9}, 
   3.783848946105035*^9, {3.7839271259961653`*^9, 3.7839271343813*^9}, {
   3.78393203979464*^9, 3.783932043129283*^9}, {3.78394684957181*^9, 
   3.783946853592836*^9}},
 CellLabel->"In[81]:=",ExpressionUUID->"ad968fa0-9cb0-4cca-a39a-bf0cf02f62f5"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Numeric part fermionic", "Title",
 CellChangeTimes->{{3.735019543581385*^9, 3.7350195455469885`*^9}, {
  3.735113072612387*^9, 3.7351130755451927`*^9}, {3.78377221589954*^9, 
  3.783772232442075*^9}, {3.783839090441724*^9, 3.783839096199328*^9}, {
  3.783935366227022*^9, 3.783935389401977*^9}, {3.784897099985105*^9, 
  3.784897100873666*^9}},ExpressionUUID->"afa5c16a-da02-4911-bdf7-\
e6bdef97fa9d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Print", "[", "\"\<Fermionic part...\>\"", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.808198829912356*^9, 3.808198840356933*^9}, {
  3.808207559231138*^9, 3.808207559593259*^9}},
 CellLabel->"In[82]:=",ExpressionUUID->"9317f807-46ca-4919-a2bd-993050066e43"],

Cell[BoxData["\<\"Fermionic part...\"\>"], "Print",
 CellChangeTimes->{3.808217976826747*^9, 3.808536387084814*^9, 
  3.808625320706407*^9, 3.810893556576404*^9, 3.811840852575397*^9, 
  3.811840928240193*^9, 3.827291038849189*^9, 3.8272911028612022`*^9, 
  3.8272945293854237`*^9, 3.831093304783436*^9, 3.844874710885663*^9},
 CellLabel->
  "During evaluation of \
In[82]:=",ExpressionUUID->"bdc2e3d5-e0c6-4c86-a9a7-71e221e05e38"]
}, Open  ]],

Cell["\<\
Set some variables used in the fermionic mass matrices and further \
simplifying assumptions \
\>", "Text",
 CellChangeTimes->{{3.7492267532580385`*^9, 3.749226777556428*^9}, {
   3.783689651173581*^9, 3.783689663058991*^9}, 
   3.783935381706771*^9},ExpressionUUID->"0b32db2e-6a38-4841-a8e0-\
aa0a2bd30776"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MB1", " ", "=", " ", 
    RowBox[{"x1B", " ", "MB"}]}], ";", " ", 
   RowBox[{"MB2", " ", "=", " ", 
    RowBox[{"x2B", " ", "MB"}]}], ";", " ", 
   RowBox[{"MB3", " ", "=", " ", 
    RowBox[{
     RowBox[{"x3B", " ", "MB"}], "/.", 
     RowBox[{"x3B", "\[Rule]", 
      RowBox[{"1", "-", "x1B", "-", "x2B"}]}]}]}], ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MW1", " ", "=", " ", 
    RowBox[{"x1W", " ", "MW"}]}], ";", " ", 
   RowBox[{"MW2", " ", "=", " ", 
    RowBox[{"x2W", " ", "MW"}]}], ";", " ", 
   RowBox[{"MW3", " ", "=", " ", 
    RowBox[{
     RowBox[{"x3W", " ", "MW"}], "/.", 
     RowBox[{"x3W", "\[Rule]", 
      RowBox[{"1", "-", "x1W", "-", "x2W"}]}]}]}], ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m2u1", " ", "=", " ", 
   RowBox[{"x1u", " ", "m2u"}]}], ";", 
  RowBox[{"m2u2", " ", "=", " ", 
   RowBox[{"x2u", " ", "m2u"}]}], ";", 
  RowBox[{"m2u3", " ", "=", " ", 
   RowBox[{
    RowBox[{"x3u", " ", "m2u"}], "/.", 
    RowBox[{"x3u", "\[Rule]", 
     RowBox[{"1", "-", "x1u", "-", "x2u"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m2d1", " ", "=", " ", 
   RowBox[{"x1d", " ", "m2d"}]}], ";", 
  RowBox[{"m2d2", " ", "=", " ", 
   RowBox[{"x2d", " ", "m2d"}]}], ";", 
  RowBox[{"m2d3", " ", "=", " ", 
   RowBox[{
    RowBox[{"x3d", " ", "m2d"}], "/.", 
    RowBox[{"x3d", "\[Rule]", 
     RowBox[{"1", "-", "x1d", "-", "x2d"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m2s1", " ", "=", " ", 
   RowBox[{"x1s", " ", "m2s"}]}], ";", 
  RowBox[{"m2s2", " ", "=", " ", 
   RowBox[{"x2s", " ", "m2s"}]}], ";", 
  RowBox[{"m2s3", " ", "=", " ", 
   RowBox[{
    RowBox[{"x3s", " ", "m2s"}], "/.", 
    RowBox[{"x3s", "\[Rule]", 
     RowBox[{"1", "-", "x1s", "-", "x2s"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"A\[Lambda]1", " ", "=", " ", 
   RowBox[{"x1A\[Lambda]", " ", "A\[Lambda]"}]}], ";", " ", 
  RowBox[{"A\[Lambda]2", " ", "=", " ", 
   RowBox[{"x2A\[Lambda]", " ", "A\[Lambda]"}]}], ";", " ", 
  RowBox[{"A\[Lambda]3", " ", "=", " ", 
   RowBox[{
    RowBox[{"x3A\[Lambda]", " ", "A\[Lambda]"}], "/.", 
    RowBox[{"x3A\[Lambda]", "\[Rule]", 
     RowBox[{"1", "-", "x1A\[Lambda]", "-", "x2A\[Lambda]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ak1", " ", "=", " ", 
   RowBox[{"x1Ak", " ", "Ak"}]}], ";", " ", 
  RowBox[{"Ak2", " ", "=", " ", 
   RowBox[{"x2Ak", " ", "Ak"}]}], ";", " ", 
  RowBox[{"Ak3", " ", "=", " ", 
   RowBox[{
    RowBox[{"x3Ak", " ", "Ak"}], "/.", 
    RowBox[{"x3Ak", "\[Rule]", 
     RowBox[{"1", "-", "x1Ak", "-", "x2Ak"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"ngld", "\[Equal]", "3"}], ",", 
      RowBox[{
       RowBox[{"Mgld12", " ", "=", " ", "Mgld"}], ";", " ", 
       RowBox[{"Mgld13", " ", "=", " ", "Mgld"}], ";", " ", 
       RowBox[{"Mgld23", " ", "=", " ", "Mgld"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ngld", "\[Equal]", "2"}], ",", 
        RowBox[{
         RowBox[{"Mgld12", " ", "=", " ", "Mgld"}], ";", " ", 
         RowBox[{"Mgld13", " ", "=", " ", "0"}], ";", " ", 
         RowBox[{"Mgld23", " ", "=", " ", "0"}]}]}], "]"}]}], "]"}], ";"}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{
  3.749224966562845*^9, {3.778409890667272*^9, 3.7784099106448*^9}, {
   3.7836896663422937`*^9, 3.783689668365823*^9}, {3.783689713852518*^9, 
   3.783689741091867*^9}, {3.7837720473380747`*^9, 3.783772047471431*^9}, {
   3.783836487036401*^9, 3.783836553253035*^9}, {3.783836604950287*^9, 
   3.783836756044742*^9}, {3.783836840142682*^9, 3.783836844714291*^9}, {
   3.783836906121024*^9, 3.783836984559626*^9}, {3.78392321266123*^9, 
   3.7839232424052687`*^9}, {3.7839353222538147`*^9, 3.783935323692923*^9}, {
   3.7848972361258917`*^9, 3.784897238133054*^9}, {3.807871606121451*^9, 
   3.807871643968979*^9}, {3.811833146839033*^9, 3.8118331953082323`*^9}, {
   3.81183506398733*^9, 3.8118352660918837`*^9}, 3.811835305188942*^9, 
   3.831092610628586*^9, 3.831093295008684*^9, 3.831196305365602*^9},
 CellLabel->"In[83]:=",ExpressionUUID->"91bec30f-8aa5-47c2-be32-be5c916eadb5"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"dimM", "=", "8"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Psi]tilde3", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
    "\"\<\!\(\*OverscriptBox[\(B\), \(~\)]\)\>\"", ",", " ", 
     "\"\<\!\(\*OverscriptBox[\(W\), \(~\)]\)\>\"", ",", " ", 
     "\"\<\!\(\*OverscriptBox[\(Hd\), \(~\)]\)\>\"", ",", " ", 
     "\"\<\!\(\*OverscriptBox[\(Hu\), \(~\)]\)\>\"", ",", " ", 
     "\"\<\!\(\*OverscriptBox[\(S\), \(~\)]\)\>\"", ",", " ", 
     "\"\<\!\(\*OverscriptBox[\(\[Eta]1\), \(~\)]\)\>\"", ",", " ", 
     "\"\<\!\(\*OverscriptBox[\(\[Eta]2\), \(~\)]\)\>\"", ",", " ", 
     "\"\<\!\(\*OverscriptBox[\(\[Eta]3\), \(~\)]\)\>\""}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"compo", "[", "n_", "]"}], ":=", " ", 
  RowBox[{"Print", "[", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Sort", "[", 
      SuperscriptBox[
       RowBox[{"Nmix", "[", 
        RowBox[{"[", "n", "]"}], "]"}], "2"], "]"}], "\[LeftDoubleBracket]", 
     RowBox[{"-", "1"}], "\[RightDoubleBracket]"}], ",", "\"\< \>\"", ",", 
    " ", 
    RowBox[{"\[Psi]tilde3", "\[LeftDoubleBracket]", 
     RowBox[{
      RowBox[{"Ordering", "[", 
       SuperscriptBox[
        RowBox[{"Nmix", "[", 
         RowBox[{"[", "n", "]"}], "]"}], "2"], "]"}], "\[LeftDoubleBracket]", 
      RowBox[{"-", "1"}], "\[RightDoubleBracket]"}], 
     "\[RightDoubleBracket]"}], ",", " ", "\[IndentingNewLine]", 
    "\"\< + \>\"", ",", 
    RowBox[{
     RowBox[{"Sort", "[", 
      SuperscriptBox[
       RowBox[{"Nmix", "[", 
        RowBox[{"[", "n", "]"}], "]"}], "2"], "]"}], "\[LeftDoubleBracket]", 
     RowBox[{"-", "2"}], "\[RightDoubleBracket]"}], ",", "\"\< \>\"", ",", 
    " ", 
    RowBox[{"\[Psi]tilde3", "\[LeftDoubleBracket]", 
     RowBox[{
      RowBox[{"Ordering", "[", 
       SuperscriptBox[
        RowBox[{"Nmix", "[", 
         RowBox[{"[", "n", "]"}], "]"}], "2"], "]"}], "\[LeftDoubleBracket]", 
      RowBox[{"-", "2"}], "\[RightDoubleBracket]"}], 
     "\[RightDoubleBracket]"}], ",", " ", "\"\< + \>\"", ",", 
    RowBox[{
     RowBox[{"Sort", "[", 
      SuperscriptBox[
       RowBox[{"Nmix", "[", 
        RowBox[{"[", "n", "]"}], "]"}], "2"], "]"}], "\[LeftDoubleBracket]", 
     RowBox[{"-", "3"}], "\[RightDoubleBracket]"}], ",", "\"\< \>\"", ",", 
    " ", 
    RowBox[{"\[Psi]tilde3", "\[LeftDoubleBracket]", 
     RowBox[{
      RowBox[{"Ordering", "[", 
       SuperscriptBox[
        RowBox[{"Nmix", "[", 
         RowBox[{"[", "n", "]"}], "]"}], "2"], "]"}], "\[LeftDoubleBracket]", 
      RowBox[{"-", "3"}], "\[RightDoubleBracket]"}], 
     "\[RightDoubleBracket]"}], ",", "\"\< + ...\>\""}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.783839117498151*^9, 3.7838392067823772`*^9}, {
   3.7838392409231997`*^9, 3.7838393344266043`*^9}, {3.783839369183065*^9, 
   3.78383939353096*^9}, {3.783839557359095*^9, 3.7838395710637712`*^9}, {
   3.783840443381735*^9, 3.783840556570703*^9}, {3.783840599318447*^9, 
   3.783840599989682*^9}, {3.783840694739807*^9, 3.78384071178865*^9}, 
   3.7838473970526*^9, {3.783847841897031*^9, 3.783847866904149*^9}, {
   3.783847928872202*^9, 3.783847936252882*^9}, {3.783848202892909*^9, 
   3.7838482184752007`*^9}, {3.783848259065096*^9, 3.783848261428657*^9}, {
   3.78384845130128*^9, 3.783848499629197*^9}, {3.7838486796561003`*^9, 
   3.783848876623457*^9}, 3.783848996327427*^9, 3.783925554399062*^9, {
   3.783935354820405*^9, 3.7839353647399*^9}, {3.783936843037797*^9, 
   3.783936857867125*^9}, {3.807870548289833*^9, 3.8078705581592007`*^9}, {
   3.807873539602498*^9, 3.8078735415874233`*^9}, {3.8079361613583508`*^9, 
   3.807936165791374*^9}},
 CellLabel->"In[90]:=",ExpressionUUID->"acc251d5-98e9-4ec2-82be-a528553dd62e"],

Cell[CellGroupData[{

Cell["Diagonalize etc...", "Subsection",
 CellChangeTimes->{{3.7839270211114073`*^9, 3.783927026773356*^9}, {
  3.78400621571104*^9, 
  3.784006220283951*^9}},ExpressionUUID->"ccff9b63-4374-4aa1-83dc-\
e7c887b991fe"],

Cell["Neutralino", "Text",
 CellChangeTimes->{{3.784006241390459*^9, 
  3.784006242868162*^9}},ExpressionUUID->"9afe8a8d-a246-4bcb-8811-\
b1a7d8c4ed7a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"massneu3num", "=", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"massneu3", "[", 
       RowBox[{"[", 
        RowBox[{"i", ",", "j"}], "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "dimM"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "dimM"}], "}"}]}], "]"}], "/.", "bench"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.7838375227032003`*^9, 3.783837542422811*^9}, {
   3.7839324949507723`*^9, 3.7839325035798883`*^9}, 3.783936884728359*^9, {
   3.783948384684079*^9, 3.783948396938286*^9}, 3.7851470394838953`*^9, {
   3.8078728394712*^9, 3.807872861663311*^9}, {3.8078733832277327`*^9, 
   3.80787338364517*^9}, {3.8078734941511917`*^9, 3.8078735103846407`*^9}, {
   3.807873546810054*^9, 3.807873553236691*^9}},
 CellLabel->"In[93]:=",ExpressionUUID->"2da9287d-8262-496e-995d-d76d70ee814f"],

Cell[CellGroupData[{

Cell[BoxData["massneu3num"], "Input",
 CellChangeTimes->{{3.8078708744875593`*^9, 3.807870877731266*^9}},
 CellLabel->"In[94]:=",ExpressionUUID->"815cadc6-dd36-4d61-815c-584862dab56e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"202", ",", "0", ",", 
     RowBox[{"-", "24.451898168622833`"}], ",", "36.67784725293425`", ",", 
     "0", ",", "0.00011517396610091963`", ",", "0.005820531939700515`", ",", 
     RowBox[{"-", "0.035083779053984875`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1220", ",", "44.5862470723877`", ",", 
     RowBox[{"-", "66.87937060858154`"}], ",", "0", ",", 
     "0.0013133086066101493`", ",", "0.`", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "24.451898168622833`"}], ",", "44.5862470723877`", ",", "0",
      ",", 
     RowBox[{"-", "1507.7781745930522`"}], ",", 
     RowBox[{"-", "159.34923281910443`"}], ",", "0.10558475843508859`", ",", 
     RowBox[{"-", "10.153283460379317`"}], ",", "8.622892998445044`"}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"36.67784725293425`", ",", 
     RowBox[{"-", "66.87937060858154`"}], ",", 
     RowBox[{"-", "1507.7781745930522`"}], ",", "0", ",", 
     RowBox[{"-", "106.23282187940296`"}], ",", "0.03767871057054787`", ",", 
     RowBox[{"-", "4.676526903448984`"}], ",", "12.167037240826279`"}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", 
     RowBox[{"-", "159.34923281910443`"}], ",", 
     RowBox[{"-", "106.23282187940296`"}], ",", "2288.9714439820923`", ",", 
     "2.2989221745162234`", ",", 
     RowBox[{"-", "20.497567958499946`"}], ",", 
     RowBox[{"-", "44.661705541513804`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.00011517396610091963`", ",", "0.0013133086066101493`", ",", 
     "0.10558475843508859`", ",", "0.03767871057054787`", ",", 
     "2.2989221745162234`", ",", 
     RowBox[{"-", "0.0265`"}], ",", "0.9`", ",", "0.85`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.005820531939700515`", ",", "0.`", ",", 
     RowBox[{"-", "10.153283460379317`"}], ",", 
     RowBox[{"-", "4.676526903448984`"}], ",", 
     RowBox[{"-", "20.497567958499946`"}], ",", "0.9`", ",", 
     RowBox[{"-", "45.45`"}], ",", "0.9`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.035083779053984875`"}], ",", "0.`", ",", 
     "8.622892998445044`", ",", "12.167037240826279`", ",", 
     RowBox[{"-", "44.661705541513804`"}], ",", "0.85`", ",", "0.9`", ",", 
     RowBox[{"-", "86.8`"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.8078708781965427`*^9, 3.807871025552588*^9, 
  3.807872790890149*^9, 3.807873556649654*^9, 3.8079361936687117`*^9, 
  3.807936441587061*^9, 3.807940689615284*^9, 3.808033668842655*^9, 
  3.808195436467155*^9, 3.808217131917171*^9, 3.8082179769235992`*^9, 
  3.8085363871610603`*^9, 3.808625320778466*^9, 3.81089355665646*^9, 
  3.811840852653261*^9, 3.8118409283015127`*^9, 3.827291038950192*^9, 
  3.8272911029293003`*^9, 3.827294529457222*^9, 3.831093304874914*^9, 
  3.8448747109343452`*^9},
 CellLabel->"Out[94]=",ExpressionUUID->"6c8f11dd-c781-4341-a048-9d2e8ee3e1ca"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"M\[Chi]", "=", 
  RowBox[{
   RowBox[{"Reverse", "[", 
    RowBox[{
     RowBox[{"Eigensystem", "[", "massneu3num", "]"}], "\[LeftDoubleBracket]",
      "1", "\[RightDoubleBracket]"}], "]"}], "//", "Chop"}]}]], "Input",
 CellChangeTimes->{{3.78377266658185*^9, 3.783772730963071*^9}, {
   3.783837064474823*^9, 3.783837083125971*^9}, {3.783837131947834*^9, 
   3.783837156605651*^9}, {3.783837303958125*^9, 3.7838373176119556`*^9}, {
   3.7838374306479588`*^9, 3.783837438147977*^9}, {3.7838375532769413`*^9, 
   3.783837559290822*^9}, {3.783838427835779*^9, 3.7838384468993387`*^9}, {
   3.783847425375*^9, 3.783847465709817*^9}, 3.783848941870492*^9, 
   3.7838614807323027`*^9, {3.784006938871895*^9, 3.784006951275929*^9}},
 CellLabel->"In[95]:=",ExpressionUUID->"957707db-4e41-49f8-95bd-4b64c6ac1eba"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.0008801443750598992`"}], ",", 
   RowBox[{"-", "45.5566574326549`"}], ",", 
   RowBox[{"-", "87.57194068018634`"}], ",", "200.60597971274774`", ",", 
   "1199.931591712559`", ",", 
   RowBox[{"-", "1517.3773269104095`"}], ",", "1527.6180688247046`", ",", 
   "2301.0461088997104`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.783861482433579*^9, 3.783861667854424*^9, 3.78386189065016*^9, 
   3.7839227037480917`*^9, 3.783925562494842*^9, {3.7839369037238617`*^9, 
   3.783936908272318*^9}, 3.783947834456015*^9, 3.783948403711101*^9, 
   3.783949597069248*^9, 3.784005989216414*^9, {3.784006267416544*^9, 
   3.7840062898838367`*^9}, {3.784006940200075*^9, 3.784006951674287*^9}, 
   3.784006995793777*^9, 3.7840077896820097`*^9, 3.7840141499021187`*^9, 
   3.784014233085834*^9, 3.784020762075736*^9, 3.784021755401726*^9, 
   3.784022894515954*^9, 3.784023069053235*^9, 3.7840231641087227`*^9, {
   3.7840232071408854`*^9, 3.784023227876227*^9}, 3.784024160763088*^9, 
   3.784024281360111*^9, 3.7840254017211933`*^9, 3.7840269151903553`*^9, 
   3.784026995177636*^9, 3.784897257999668*^9, 3.7848976584889174`*^9, 
   3.784961768853456*^9, 3.784965690596266*^9, 3.7849672295330353`*^9, 
   3.784973558187381*^9, 3.784974045808029*^9, 3.7849746861531982`*^9, 
   3.784975056822463*^9, 3.7849751278875427`*^9, 3.784977163151782*^9, 
   3.78514338625753*^9, 3.78514658529854*^9, 3.7851634323595324`*^9, 
   3.78516381159683*^9, 3.785239479320202*^9, 3.7852395814063807`*^9, 
   3.785242431360468*^9, 3.785747917182782*^9, 3.7857539574159403`*^9, 
   3.787898615239642*^9, 3.78825720818854*^9, 3.807873584202239*^9, 
   3.807936445754469*^9, 3.807940689631172*^9, 3.808033668862446*^9, 
   3.808195436488345*^9, 3.8082171344697657`*^9, 3.8082179769402027`*^9, 
   3.808536387178146*^9, 3.808625320798542*^9, 3.8108935566744556`*^9, 
   3.81184085269985*^9, 3.811840928317493*^9, 3.8272910390649023`*^9, 
   3.827291102943622*^9, 3.827294529471189*^9, 3.831093304891736*^9, 
   3.844874710953026*^9},
 CellLabel->"Out[95]=",ExpressionUUID->"fd64e272-291b-44e8-99b6-9997de5215ef"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Nmix", "=", 
   RowBox[{
    RowBox[{"Reverse", "[", 
     RowBox[{
      RowBox[{"Eigensystem", "[", "massneu3num", "]"}], 
      "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "]"}], "//", 
    "Chop"}]}], " ", ";"}]], "Input",
 CellChangeTimes->{{3.783847478923912*^9, 3.783847484383095*^9}, 
   3.783848946105035*^9, {3.784006639113447*^9, 3.784006655865197*^9}, {
   3.784006944108612*^9, 3.7840069577985153`*^9}, {3.784022299071006*^9, 
   3.78402230350248*^9}, 3.7840224021853867`*^9},
 CellLabel->"In[96]:=",ExpressionUUID->"052c5b0b-6001-4407-bba9-2424bd370169"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
    RowBox[{"Nmix", ".", "massneu3num", ".", 
     RowBox[{"Nmix", "\[Transpose]"}]}], "//", "Chop"}], "//", "MatrixForm"}],
   "*)"}]], "Input",
 CellChangeTimes->{{3.783837460809395*^9, 3.783837498809059*^9}, {
  3.7838375649712257`*^9, 3.7838375654244623`*^9}, {3.783840895648617*^9, 
  3.783840909547667*^9}, {3.783847504358795*^9, 3.783847508067021*^9}, {
  3.7840062599382153`*^9, 3.784006270885137*^9}, {3.784006924343659*^9, 
  3.784006971829406*^9}},
 CellLabel->"In[97]:=",ExpressionUUID->"b239f8c9-073c-44dc-9e5f-94c0b17f07d9"],

Cell["Chargino", "Text",
 CellChangeTimes->{{3.784006302083693*^9, 
  3.784006303900869*^9}},ExpressionUUID->"edace532-cd1b-42ea-988d-\
b04131a4fca9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"masscharnum", " ", "=", " ", 
   RowBox[{"masschar", "/.", "bench"}]}], ";"}]], "Input",
 CellChangeTimes->{
  3.784006203799234*^9, {3.784006311065589*^9, 3.784006320040457*^9}, {
   3.7840063504054823`*^9, 3.784006361909273*^9}, {3.784006977089406*^9, 
   3.784007019350031*^9}, 3.785147054202735*^9},
 CellLabel->"In[98]:=",ExpressionUUID->"8451f892-6b64-4fcc-b8ee-0599e592463d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"masscharSVD", "=", 
   RowBox[{"SingularValueDecomposition", "[", "masscharnum", "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.783935711771749*^9, 3.783935762285035*^9}, {
   3.783936204707672*^9, 3.783936220283245*^9}, 3.783936967958638*^9, {
   3.783947184981472*^9, 3.783947189426469*^9}, {3.78394853300983*^9, 
   3.7839485370365562`*^9}, {3.783948748485515*^9, 3.78394875621312*^9}, {
   3.783950137079055*^9, 3.783950168109137*^9}, {3.783950358091462*^9, 
   3.783950383636747*^9}, {3.78395041917881*^9, 3.783950423767342*^9}, 
   3.783950643194553*^9, {3.783950691345812*^9, 3.7839507087817993`*^9}, {
   3.783950739771435*^9, 3.783950749157157*^9}, {3.783950779542354*^9, 
   3.7839507888765707`*^9}, 3.783950838622383*^9},
 CellLabel->"In[99]:=",ExpressionUUID->"d35a8810-b296-4a74-be8b-901158501389"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"Umix", " ", "=", " ", 
    RowBox[{
     RowBox[{"masscharSVD", "[", 
      RowBox[{"[", "1", "]"}], "]"}], "\[ConjugateTranspose]"}]}], ";", 
   "\[IndentingNewLine]", 
   RowBox[{"Vmix", " ", "=", " ", 
    RowBox[{
     RowBox[{"masscharSVD", "[", 
      RowBox[{"[", "3", "]"}], "]"}], "\[Transpose]"}]}], ";"}], 
  "*)"}]], "Input",
 CellChangeTimes->{{3.783935711771749*^9, 3.783935762285035*^9}, {
   3.783936204707672*^9, 3.783936220283245*^9}, 3.783936967958638*^9, {
   3.783947184981472*^9, 3.783947189426469*^9}, {3.78394853300983*^9, 
   3.7839485370365562`*^9}, {3.783948748485515*^9, 3.78394875621312*^9}, {
   3.783950137079055*^9, 3.783950168109137*^9}, {3.783950358091462*^9, 
   3.783950383636747*^9}, {3.78395041917881*^9, 3.783950423767342*^9}, 
   3.783950643194553*^9, {3.783950691345812*^9, 3.7839507087817993`*^9}, {
   3.783950739771435*^9, 3.783950749157157*^9}, {3.783950779542354*^9, 
   3.7839507888765707`*^9}, 3.783950838622383*^9, {3.784020722521255*^9, 
   3.784020740080573*^9}, 3.812173859197494*^9, 3.8121809675812683`*^9},
 CellLabel->
  "In[100]:=",ExpressionUUID->"b9f09362-39bd-4c71-9d02-da4503297e34"],

Cell["\<\
The mass matrix is wrongly defined, see (2.34) 0910.1785, it should be M^T so \
we have to flip U and V\
\>", "Text",
 CellChangeTimes->{{3.812180975242958*^9, 3.812180986169429*^9}, {
  3.812181058332862*^9, 
  3.81218110041157*^9}},ExpressionUUID->"f4fdb21c-9b3d-4fbf-b43d-\
936745e2f115"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Vmix", " ", "=", " ", 
   RowBox[{
    RowBox[{"masscharSVD", "[", 
     RowBox[{"[", "1", "]"}], "]"}], "\[ConjugateTranspose]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Umix", " ", "=", " ", 
   RowBox[{
    RowBox[{"masscharSVD", "[", 
     RowBox[{"[", "3", "]"}], "]"}], "\[Transpose]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.812181091592013*^9, 3.81218109324728*^9}},
 CellLabel->
  "In[101]:=",ExpressionUUID->"d6e40327-cc40-426e-97c5-d7669aeb2157"],

Cell[BoxData[
 RowBox[{
  RowBox[{"masscharDiag", " ", "=", " ", 
   RowBox[{"Diagonal", "[", 
    RowBox[{"masscharSVD", "[", 
     RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.783935711771749*^9, 3.783935762285035*^9}, {
   3.783936204707672*^9, 3.783936220283245*^9}, 3.783936967958638*^9, {
   3.783947184981472*^9, 3.783947189426469*^9}, {3.78394853300983*^9, 
   3.7839485370365562`*^9}, {3.783948748485515*^9, 3.78394875621312*^9}, {
   3.783950137079055*^9, 3.783950168109137*^9}, {3.783950358091462*^9, 
   3.783950383636747*^9}, {3.78395041917881*^9, 3.783950423767342*^9}, 
   3.783950643194553*^9, {3.783950691345812*^9, 3.7839507087817993`*^9}, {
   3.783950739771435*^9, 3.783950749157157*^9}, {3.783950779542354*^9, 
   3.7839507888765707`*^9}, 3.783950838622383*^9, {3.812181753616405*^9, 
   3.812181755742858*^9}},
 CellLabel->
  "In[103]:=",ExpressionUUID->"24014112-07ff-411e-8b67-82ab8a73f38c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"orderchar", "=", 
   RowBox[{"Ordering", "[", "masscharDiag", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.812181785450348*^9, 3.812181800673108*^9}},
 CellLabel->
  "In[104]:=",ExpressionUUID->"41fd183b-ff17-4585-8cd3-d35177b9c145"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mchar", " ", "=", " ", 
   RowBox[{"masscharDiag", "[", 
    RowBox[{"[", "orderchar", "]"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.783935711771749*^9, 3.783935762285035*^9}, {
   3.783936204707672*^9, 3.783936220283245*^9}, 3.783936967958638*^9, {
   3.783947184981472*^9, 3.783947189426469*^9}, {3.78394853300983*^9, 
   3.7839485370365562`*^9}, {3.783948748485515*^9, 3.78394875621312*^9}, {
   3.783950137079055*^9, 3.783950168109137*^9}, {3.783950358091462*^9, 
   3.783950383636747*^9}, {3.78395041917881*^9, 3.783950423767342*^9}, 
   3.783950643194553*^9, {3.783950691345812*^9, 3.7839507087817993`*^9}, {
   3.783950739771435*^9, 3.783950749157157*^9}, {3.783950779542354*^9, 
   3.7839507888765707`*^9}, 3.783950838622383*^9, {3.812181804895503*^9, 
   3.812181831810092*^9}, {3.812181990226324*^9, 3.812181995346582*^9}, {
   3.8121843048657207`*^9, 3.812184306807288*^9}},
 CellLabel->
  "In[105]:=",ExpressionUUID->"aa189f33-04a2-4510-bb34-afccd560d845"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"masscharnum", " ", "//", 
    RowBox[{"MatrixForm", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Umix", "\[Transpose]"}], ".", "masscharDiag", ".", 
      "Vmix"}]}]}], " ", "//", "MatrixForm"}], "*)"}]], "Input",
 CellChangeTimes->{{3.783948722631484*^9, 3.783948737944768*^9}, {
   3.783948775419716*^9, 3.783948799672419*^9}, {3.78395018258916*^9, 
   3.7839501916666183`*^9}, {3.78395028004449*^9, 3.783950317813221*^9}, {
   3.784006415564217*^9, 3.7840064254279747`*^9}, {3.784006897811863*^9, 
   3.7840069114512157`*^9}, {3.784007023748664*^9, 3.784007035435898*^9}, {
   3.7840070719558077`*^9, 3.78400709449746*^9}, {3.784014143492201*^9, 
   3.7840141845949917`*^9}, {3.808217199043589*^9, 3.808217200109749*^9}, 
   3.808217230401093*^9},
 CellLabel->
  "In[106]:=",ExpressionUUID->"68106386-e04f-4cbe-9560-75c4e77da5cc"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Vmix", "=", 
   RowBox[{"Vmix", "[", 
    RowBox[{"[", "orderchar", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Umix", "=", 
   RowBox[{"Umix", "[", 
    RowBox[{"[", "orderchar", "]"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.812181633057794*^9, 3.812181652197784*^9}, {
  3.812181840207562*^9, 3.812181871049012*^9}},
 CellLabel->
  "In[107]:=",ExpressionUUID->"cfa2d4b6-1ff6-40ee-ad5d-dbfabfdc0fb8"],

Cell["Check", "Text",
 CellChangeTimes->{{3.812182267186591*^9, 
  3.812182267694409*^9}},ExpressionUUID->"d24f5b4a-58c3-4e0d-800b-\
9bba94e422ed"],

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Diagonal", "[", 
      RowBox[{
       RowBox[{"Vmix", "\[Conjugate]"}], ".", "masscharnum", ".", 
       RowBox[{"Umix", "\[ConjugateTranspose]"}]}], "]"}], "\[NotEqual]", 
     "mchar"}], ",", 
    RowBox[{"Quit", "[", "]"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.812182004469962*^9, 3.812182102478661*^9}, {
  3.812182274677208*^9, 3.8121823411892443`*^9}},
 CellLabel->
  "In[109]:=",ExpressionUUID->"44228d9c-a34a-499f-b79c-7dbc198c2c45"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Widths", "Subsection",
 CellChangeTimes->{{3.783949101860695*^9, 
  3.783949103699396*^9}},ExpressionUUID->"f4eac110-e932-4e31-93e7-\
09db3c12d76a"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"A\[Gamma]", "[", 
      RowBox[{"i", ",", "k"}], "]"}], "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "/", "2"}], ")"}], 
       RowBox[{"(", "\[IndentingNewLine]", "  ", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"MB1", " ", 
            RowBox[{"c\[Theta]", "/", "f1"}]}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"i", ",", "1"}], "\[RightDoubleBracket]"}], 
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"k", ",", "6"}], "\[RightDoubleBracket]"}]}], " ", "-", 
            " ", 
            RowBox[{
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"k", ",", "1"}], "\[RightDoubleBracket]"}], 
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"i", ",", "6"}], "\[RightDoubleBracket]"}]}]}], ")"}]}],
          "+", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"MB2", " ", 
            RowBox[{"c\[Theta]", "/", "f2"}]}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"i", ",", "1"}], "\[RightDoubleBracket]"}], 
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"k", ",", "7"}], "\[RightDoubleBracket]"}]}], " ", "-", 
            " ", 
            RowBox[{
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"k", ",", "1"}], "\[RightDoubleBracket]"}], 
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"i", ",", "7"}], "\[RightDoubleBracket]"}]}]}], ")"}]}],
          "+", " ", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"MB3", " ", 
            RowBox[{"c\[Theta]", "/", "f3"}]}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"i", ",", "1"}], "\[RightDoubleBracket]"}], 
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"k", ",", "8"}], "\[RightDoubleBracket]"}]}], " ", "-", 
            " ", 
            RowBox[{
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"k", ",", "1"}], "\[RightDoubleBracket]"}], 
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"i", ",", "8"}], "\[RightDoubleBracket]"}]}]}], ")"}]}],
          "+", " ", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"MW1", " ", 
            RowBox[{"s\[Theta]", "/", "f1"}]}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"i", ",", "2"}], "\[RightDoubleBracket]"}], 
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"k", ",", "6"}], "\[RightDoubleBracket]"}]}], " ", "-", 
            " ", 
            RowBox[{
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"k", ",", "2"}], "\[RightDoubleBracket]"}], 
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"i", ",", "6"}], "\[RightDoubleBracket]"}]}]}], ")"}]}],
          "+", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"MW2", " ", 
            RowBox[{"s\[Theta]", "/", "f2"}]}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"i", ",", "2"}], "\[RightDoubleBracket]"}], 
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"k", ",", "7"}], "\[RightDoubleBracket]"}]}], " ", "-", 
            " ", 
            RowBox[{
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"k", ",", "2"}], "\[RightDoubleBracket]"}], 
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"i", ",", "7"}], "\[RightDoubleBracket]"}]}]}], ")"}]}],
          "+", " ", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"MW3", " ", 
            RowBox[{"s\[Theta]", "/", "f3"}]}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"i", ",", "2"}], "\[RightDoubleBracket]"}], 
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"k", ",", "8"}], "\[RightDoubleBracket]"}]}], " ", "-", 
            " ", 
            RowBox[{
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"k", ",", "2"}], "\[RightDoubleBracket]"}], 
             RowBox[{"Nmix", "\[LeftDoubleBracket]", 
              RowBox[{"i", ",", "8"}], "\[RightDoubleBracket]"}]}]}], 
           ")"}]}]}], "\[IndentingNewLine]", ")"}]}], "/.", "bench"}]}], ",", 
    " ", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "dimM"}], "}"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"k", ",", "1", ",", "dimM"}], "}"}]}], "]"}], "*)"}]], "Input",
 CellChangeTimes->{{3.783922648759428*^9, 3.783922667780705*^9}, {
   3.783922707966167*^9, 3.7839227990867577`*^9}, {3.783922833265223*^9, 
   3.783922956501292*^9}, {3.783922986587912*^9, 3.783923156007247*^9}, {
   3.783923331651723*^9, 3.783923357280539*^9}, 3.783936928522811*^9, {
   3.783948437972212*^9, 3.783948465158358*^9}, 3.783949904527108*^9, 
   3.785147066252713*^9},
 CellLabel->
  "In[110]:=",ExpressionUUID->"bcf6b3c4-356c-4de3-b9be-759248f6a46d"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"A\[Gamma]", "[", 
       RowBox[{"i", ",", "k"}], "]"}], "//", "Chop"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "dimM"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"k", ",", "1", ",", "dimM"}], "}"}]}], "]"}], "//", 
   "MatrixForm"}], "*)"}]], "Input",
 CellChangeTimes->{{3.783923164851108*^9, 3.783923184597753*^9}, {
  3.783923415557479*^9, 3.78392344877347*^9}, {3.7839257161795*^9, 
  3.7839257176295757`*^9}},
 CellLabel->
  "In[111]:=",ExpressionUUID->"27b82e4d-d306-4c6e-a19b-dbf2487addbf"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"\[CapitalGamma]", "[", 
      RowBox[{"i_", ",", " ", "j_"}], "]"}], ":=", " ", 
     RowBox[{"0", "/;", " ", 
      RowBox[{"i", "\[LessEqual]", " ", "j"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[CapitalGamma]", "[", 
     RowBox[{"i_", ",", " ", "j_"}], "]"}], ":=", " ", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"A\[Gamma]", "[", 
       RowBox[{"i", ",", "j"}], "]"}], "2"], " ", 
     SuperscriptBox[
      RowBox[{"Abs", "[", 
       RowBox[{
       "M\[Chi]", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], 
       "]"}], "3"], " ", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{
          SuperscriptBox[
           RowBox[{
           "M\[Chi]", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
           "2"], "/", 
          SuperscriptBox[
           RowBox[{
           "M\[Chi]", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], 
           "2"]}]}], ")"}], "3"], "/", 
      RowBox[{"(", 
       RowBox[{"4", " ", "\[Pi]"}], " ", ")"}]}]}]}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.7839496034144583`*^9, 3.783949677690658*^9}, {
   3.783949715177685*^9, 3.783949816878325*^9}, {3.783949884028719*^9, 
   3.7839499146325808`*^9}, 3.785143048164111*^9},
 CellLabel->
  "In[112]:=",ExpressionUUID->"e85816af-a678-44c7-93d5-c3105b0c4474"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"\[CapitalGamma]", "[", 
      RowBox[{"i", ",", "k"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "dimM"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"k", ",", "1", ",", "dimM"}], "}"}]}], "]"}], "//", 
   "MatrixForm"}], "*)"}]], "Input",
 CellChangeTimes->{{3.783949864922667*^9, 3.7839498672129*^9}, {
   3.784976280460095*^9, 3.784976293779951*^9}, 3.784976919452907*^9, 
   3.785238766027862*^9, 3.808218595626268*^9},
 CellLabel->
  "In[113]:=",ExpressionUUID->"9d1be9fd-527e-497d-9244-af2791f76f8e"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generate input and param_card.dat", "Title",
 CellChangeTimes->{{3.785488130103586*^9, 
  3.785488137608198*^9}},ExpressionUUID->"8e4230e1-51eb-432e-9f30-\
6f5592d7a4d4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Print", "[", "\"\<Generating input and param_card\>\"", 
  "]"}]], "Input",
 CellChangeTimes->{{3.80820680635785*^9, 3.808206820941296*^9}},
 CellLabel->
  "In[114]:=",ExpressionUUID->"5e617bbf-9e90-48d4-90e4-32321fd23d4c"],

Cell[BoxData["\<\"Generating input and param_card\"\>"], "Print",
 CellChangeTimes->{3.8085364350959473`*^9, 3.808625320866508*^9, 
  3.827291039404809*^9, 3.827291115743883*^9, 3.8272945295489407`*^9, 
  3.844874711039118*^9},
 CellLabel->
  "During evaluation of \
In[114]:=",ExpressionUUID->"f0f1ed6f-a835-4be8-a8f1-9205824197fd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDirectory", "[", "Modelpath", "]"}], ";"}]], "Input",
 CellLabel->
  "In[115]:=",ExpressionUUID->"8ad90e10-75e1-47e5-9a3f-9587e4ba176b"],

Cell[BoxData[
 TemplateBox[{
  "SetDirectory", "badfile", 
   "\"The specified argument \\!\\(\\*RowBox[{\\\"Modelpath\\\"}]\\) should \
be a valid string or File.\"", 2, 115, 1, 32161659484937378821, "Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.8448747110823936`*^9},
 CellLabel->
  "During evaluation of \
In[115]:=",ExpressionUUID->"af699f4c-f699-42c8-96e7-a9a095eab4a6"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"kind", " ", "=", " ", "0"}], ";"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Print", "[", "\"\<=== Write input.txt =====\>\"", "]"}], ";"}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"inp", "=", 
     RowBox[{"OpenWrite", "[", 
      RowBox[{"\"\<input\>\"", "<>", 
       RowBox[{"ToString", "[", "kind", "]"}], "<>", "\"\<.txt\>\""}], 
      "]"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"inp", "=", 
     RowBox[{"OpenWrite", "[", "\"\<input.txt\>\"", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Print", "[", "\"\<Bosonic parameters\>\"", "]"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", "\"\<tb = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"tan\[Beta]", "/.", "bench"}], "]"}], ",", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", "\"\<NMk = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"k", "/.", "bench"}], "]"}], ",", "\"\<\\n\>\""}], "]"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", "\"\<NMl = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"\[Lambda]", "/.", "bench"}], "]"}], ",", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", "\"\<NMAl = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"A\[Lambda]", "/.", "bench"}], "]"}], ",", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", "\"\<NMAk = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"Ak", "/.", "bench"}], "]"}], ",", "\"\<\\n\>\""}], "]"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", "\"\<mueff = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{
        RowBox[{"\[Lambda]", " ", 
         RowBox[{"vs", "/", 
          SqrtBox["2"]}]}], "/.", "bench"}], "]"}], ",", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Print", "[", "\"\<MB\>\"", "]"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<MBt1 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"MB1", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<MBt2 = \>\"", ",", 
      RowBox[{"FortranForm", "[", " ", 
       RowBox[{"MB2", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<MBt3 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"MB3", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<RMx1 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"MB", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], "]"}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Print", "[", "\"\<MW\>\"", "]"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<MWt1 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"MW1", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<MWt2 = \>\"", ",", 
      RowBox[{"FortranForm", "[", " ", 
       RowBox[{"MW2", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<MWt3 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"MW3", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<RMx2 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"MW", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], "]"}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Print", "[", "\"\<f\>\"", "]"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<fsca1 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"f1", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], "]"}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<fsca2 = \>\"", ",", 
      RowBox[{"FortranForm", "[", " ", 
       RowBox[{"f2", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], "]"}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<fsca3 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"f3", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], "]"}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Print", "[", "\"\<mH,mS\>\"", "]"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<M2Hut1 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"m2u1", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<M2Hut2 = \>\"", ",", 
      RowBox[{"FortranForm", "[", " ", 
       RowBox[{"m2u2", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<M2Hut3 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"m2u3", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<M2Hdt1 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"m2d1", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<M2Hdt2 = \>\"", ",", 
      RowBox[{"FortranForm", "[", " ", 
       RowBox[{"m2d2", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<M2Hdt3 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"m2d3", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<M2St1 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"m2s1", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<M2St2 = \>\"", ",", 
      RowBox[{"FortranForm", "[", " ", 
       RowBox[{"m2s2", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<M2St3 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"m2s3", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Print", "[", "\"\<A\>\"", "]"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<Alt1 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"A\[Lambda]1", "/.", "bench"}], "]"}], ",", " ", 
      "\"\<\\n\>\""}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<Alt2 = \>\"", ",", 
      RowBox[{"FortranForm", "[", " ", 
       RowBox[{"A\[Lambda]2", "/.", "bench"}], "]"}], ",", " ", 
      "\"\<\\n\>\""}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<Alt3 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"A\[Lambda]3", "/.", "bench"}], "]"}], ",", " ", 
      "\"\<\\n\>\""}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<Akt1 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"Ak1", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<Akt2 = \>\"", ",", 
      RowBox[{"FortranForm", "[", " ", 
       RowBox[{"Ak2", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<Akt3 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"Ak3", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Print", "[", "\"\<m3\>\"", "]"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<mHu2 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"m2u", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<mHd2 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"m2d", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<MS2 = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{"m2s", "/.", "bench"}], "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Print", "[", "\"\<MA\>\"", "]"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", "\"\<MA2 = \>\"", ",", 
      RowBox[{"FortranForm", "[", "MA2", "]"}], ",", "\"\<\\n\>\""}], "]"}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Print", "[", "\"\<Masses\>\"", "]"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Print", "[", "\"\<Charged higgs\>\"", "]"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", "\"\<MH = \>\"", ",", 
      RowBox[{"FortranForm", "[", 
       RowBox[{
        RowBox[{"Reverse", "[", 
         RowBox[{"Sort", "[", "mHpm", "]"}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "\"\<\\n\>\""}], "]"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "Print", "[", 
     "\"\<Start at 2 because we input the Higgs mass mh01=125\>\"", "]"}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{"Do", "[", 
    RowBox[{"(*", 
     RowBox[{"Higgs", " ", "mass"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"WriteString", "[", 
       RowBox[{"inp", ",", 
        RowBox[{"StringForm", "[", 
         RowBox[{"\"\<MH0`1` = \>\"", ",", "i"}], "]"}], ",", 
        RowBox[{"FortranForm", "[", 
         RowBox[{"mH", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", "\"\<\\n\>\""}], "]"}], 
      ";"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"i", ",", "2", ",", "3"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Do", "[", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"A", " ", "mass"}], ",", " ", 
      RowBox[{
       RowBox[{"mA", "[", 
        RowBox[{"[", 
         RowBox[{"i", "+", "1"}], "]"}], "]"}], " ", "because", " ", "the", 
       " ", "first", " ", "entry", " ", "of", " ", "mA", " ", "is", " ", 
       "the", " ", "NGB"}]}], " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"WriteString", "[", 
       RowBox[{"inp", ",", 
        RowBox[{"StringForm", "[", 
         RowBox[{"\"\<MxA0`1` = \>\"", ",", "i"}], "]"}], ",", 
        RowBox[{"FortranForm", "[", 
         RowBox[{"mA", "[", 
          RowBox[{"[", 
           RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}], ",", "\"\<\\n\>\""}],
        "]"}], ";"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "2"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Do", "[", 
    RowBox[{"(*", 
     RowBox[{"Neutralino", " ", "mass"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"WriteString", "[", 
       RowBox[{"inp", ",", 
        RowBox[{"StringForm", "[", 
         RowBox[{"\"\<Mneu`1` = \>\"", ",", "i"}], "]"}], ",", 
        RowBox[{"FortranForm", "[", 
         RowBox[{"M\[Chi]", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", "\"\<\\n\>\""}], "]"}], 
      ";"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "8"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Do", "[", 
    RowBox[{"(*", 
     RowBox[{"Chargino", " ", "mass"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"WriteString", "[", 
       RowBox[{"inp", ",", 
        RowBox[{"StringForm", "[", 
         RowBox[{"\"\<Mch`1` = \>\"", ",", "i"}], "]"}], ",", 
        RowBox[{"FortranForm", "[", 
         RowBox[{"mchar", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", "\"\<\\n\>\""}], "]"}], 
      ";"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "2"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Print", "[", "\"\<Mixing matrices\>\"", "]"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Print", "[", "\"\<NMNMIX\>\"", "]"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Do", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"WriteString", "[", 
       RowBox[{"inp", ",", 
        RowBox[{"StringForm", "[", 
         RowBox[{"\"\<RNN`1`x`2` = \>\"", ",", "i", ",", "j"}], "]"}], ",", 
        RowBox[{"FortranForm", "[", 
         RowBox[{"Nmix", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "j"}], "]"}], "]"}], "]"}], ",", "\"\<\\n\>\""}],
        "]"}], ";"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "8"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Print", "[", "\"\<NMHMIX\>\"", "]"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Do", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"WriteString", "[", 
       RowBox[{"inp", ",", 
        RowBox[{"StringForm", "[", 
         RowBox[{"\"\<US`1`x`2` = \>\"", ",", "i", ",", "j"}], "]"}], ",", 
        RowBox[{"FortranForm", "[", 
         RowBox[{"Hmix", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "j"}], "]"}], "]"}], "]"}], ",", "\"\<\\n\>\""}],
        "]"}], ";"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Print", "[", "\"\<NMAMIX\>\"", "]"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Do", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"WriteString", "[", 
       RowBox[{"inp", ",", 
        RowBox[{"StringForm", "[", 
         RowBox[{"\"\<UP`1`x`2` = \>\"", ",", "i", ",", "j"}], "]"}], ",", 
        RowBox[{"FortranForm", "[", 
         RowBox[{"Amix", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "j"}], "]"}], "]"}], "]"}], ",", "\"\<\\n\>\""}],
        "]"}], ";"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Print", "[", "\"\<UMIX\>\"", "]"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Do", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"WriteString", "[", 
       RowBox[{"inp", ",", 
        RowBox[{"StringForm", "[", 
         RowBox[{"\"\<RUU`1`x`2` = \>\"", ",", "i", ",", "j"}], "]"}], ",", 
        RowBox[{"FortranForm", "[", 
         RowBox[{"Umix", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "j"}], "]"}], "]"}], "]"}], ",", "\"\<\\n\>\""}],
        "]"}], ";"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "2"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Print", "[", "\"\<VMIX\>\"", "]"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Do", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"WriteString", "[", 
       RowBox[{"inp", ",", 
        RowBox[{"StringForm", "[", 
         RowBox[{"\"\<RVV`1`x`2` = \>\"", ",", "i", ",", "j"}], "]"}], ",", 
        RowBox[{"FortranForm", "[", 
         RowBox[{"Vmix", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "j"}], "]"}], "]"}], "]"}], ",", "\"\<\\n\>\""}],
        "]"}], ";"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "2"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"Do", "[", 
    RowBox[{"(*", "INN", "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"WriteString", "[", 
       RowBox[{"inp", ",", 
        RowBox[{"StringForm", "[", 
         RowBox[{"\"\<INN`1`x`2` = \>\"", ",", "i", ",", "j"}], "]"}], ",", 
        "0.", ",", "\"\<\\n\>\""}], "]"}], ";"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "8"}], "}"}]}], "]"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Print", "[", "\"\< SM parameters \>\"", "]"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", "\"\<MZ = \>\"", ",", 
      RowBox[{"FortranForm", "[", "mz", "]"}], ",", "\"\<\\n\>\""}], "]"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", "\"\<MW = \>\"", ",", 
      RowBox[{"FortranForm", "[", "mw", "]"}], ",", "\"\<\\n\>\""}], "]"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", "\"\<WZ = \>\"", ",", 
      RowBox[{"FortranForm", "[", "2.4952", "]"}], ",", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", "\"\<WW = \>\"", ",", 
      RowBox[{"FortranForm", "[", "2.085", "]"}], ",", "\"\<\\n\>\""}], "]"}],
     ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", "\"\<MH01 = \>\"", ",", 
      RowBox[{"FortranForm", "[", "125.1", "]"}], ",", "\"\<\\n\>\""}], "]"}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", "\"\<WH01 = \>\"", ",", 
      RowBox[{"FortranForm", "[", "4.08*^-3", "]"}], ",", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", "\"\<aEWM1 = \>\"", ",", 
      RowBox[{"FortranForm", "[", "aEWM1", "]"}], ",", "\"\<\\n\>\""}], "]"}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"some", " ", "zeros"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<MSP2 = \>\"", ",", 
      RowBox[{"FortranForm", "[", "0.0", "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"WriteString", "[", 
     RowBox[{"inp", ",", " ", "\"\<bb = \>\"", ",", 
      RowBox[{"FortranForm", "[", "0.0", "]"}], ",", " ", "\"\<\\n\>\""}], 
     "]"}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Close", "[", "inp", "]"}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.783951480527759*^9, 3.78395148569114*^9}, {
   3.784006488225079*^9, 3.784006490783523*^9}, {3.784006760975902*^9, 
   3.784006792847876*^9}, {3.784014061846587*^9, 3.784014137339625*^9}, 
   3.7840141906507053`*^9, {3.7840227628407497`*^9, 3.784022835902686*^9}, {
   3.78402300684446*^9, 3.784023020970813*^9}, {3.784023140308895*^9, 
   3.784023159551238*^9}, {3.784024099403832*^9, 3.784024123785657*^9}, {
   3.784024229351762*^9, 3.7840242658736467`*^9}, {3.7840267183271923`*^9, 
   3.784026799540371*^9}, {3.784974311795197*^9, 3.784974319521645*^9}, {
   3.784974595096694*^9, 3.78497459762484*^9}, {3.784976605982395*^9, 
   3.7849766908981943`*^9}, {3.785145073279541*^9, 3.785145125543634*^9}, {
   3.785145188548338*^9, 3.7851453425659227`*^9}, 3.7851467484614773`*^9, {
   3.785146809606125*^9, 3.785146860613298*^9}, {3.785146898403572*^9, 
   3.7851469306028137`*^9}, {3.785147826950213*^9, 3.785147834311039*^9}, {
   3.7851520685460987`*^9, 3.785152074621307*^9}, {3.785152254253886*^9, 
   3.7851522951682034`*^9}, {3.7851523516085567`*^9, 3.785152432918193*^9}, {
   3.7851525398318663`*^9, 3.785152564048884*^9}, {3.785152639097767*^9, 
   3.7851527099425488`*^9}, {3.7851530704610987`*^9, 
   3.7851531448953047`*^9}, {3.785153282641302*^9, 3.7851532832043247`*^9}, {
   3.7851533981597223`*^9, 3.7851534187567053`*^9}, {3.78515362263089*^9, 
   3.785153641446753*^9}, {3.785153708458321*^9, 3.7851537135903177`*^9}, 
   3.785239096756412*^9, {3.7852435861261473`*^9, 3.785243674627925*^9}, {
   3.785243708213717*^9, 3.78524370836825*^9}, {3.78574804745452*^9, 
   3.78574807788937*^9}, {3.7857499057636547`*^9, 3.785749912773814*^9}, {
   3.785749959116529*^9, 3.7857500248926907`*^9}, {3.7857506710494127`*^9, 
   3.7857507046465807`*^9}, {3.785751361593391*^9, 3.785751391762267*^9}, {
   3.8079366235145407`*^9, 3.807936754698762*^9}, {3.807936804655361*^9, 
   3.807936835248312*^9}, {3.807940406776451*^9, 3.807940484147997*^9}, {
   3.808198525577983*^9, 3.808198608247048*^9}, {3.811688930562323*^9, 
   3.811688961646551*^9}, {3.811689060060842*^9, 3.811689063639255*^9}, {
   3.811692142856496*^9, 3.8116921435712757`*^9}, {3.8116921752109327`*^9, 
   3.811692192977789*^9}, {3.8117357499626913`*^9, 3.811735761061915*^9}},
 CellLabel->
  "In[116]:=",ExpressionUUID->"fbebebb9-6800-456e-88aa-765e9fcf7ff9"],

Cell["\<\
After generating input.txt you can run write_param_card_input.py\
\>", "Text",
 CellChangeTimes->{{3.844875028153933*^9, 
  3.8448750515984697`*^9}},ExpressionUUID->"651f1dc9-f7ff-41c9-b916-\
3934362c1502"],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "Run", "[", "\"\<python write_param_card_input.py input.txt\>\"", "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.785244800023178*^9, 3.785244800884194*^9}, {
  3.807948652252199*^9, 3.8079486689366503`*^9}, {3.811691683926536*^9, 
  3.8116916855811253`*^9}, {3.831092668445533*^9, 3.8310926688605127`*^9}, {
  3.831093442649487*^9, 3.8310934438952303`*^9}, {3.831093619625551*^9, 
  3.8310936328080463`*^9}, {3.8310937070392637`*^9, 3.831093719887936*^9}, {
  3.8448731510858307`*^9, 3.844873151599846*^9}},
 CellLabel->
  "In[174]:=",ExpressionUUID->"7095c5a6-2cd1-4f6d-b3ad-62145c9d6e90"]
}, Open  ]]
},
WindowSize->{1005, 903},
WindowMargins->{{34.5, Automatic}, {0, Automatic}},
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.5, 1.5 Inherited],
FrontEndVersion->"12.3 for Linux x86 (64-bit) (July 9, 2021)",
StyleDefinitions->FrontEnd`FileName[{"Creative"}, "NaturalColor.nb", 
  CharacterEncoding -> "UTF-8"],
ExpressionUUID->"1f0e1811-db34-4e36-ad5f-e5a651ef287f"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 247, 4, 63, "Input",ExpressionUUID->"0577225e-bc14-4519-9011-ca829fa0147b"],
Cell[829, 28, 227, 3, 63, "Output",ExpressionUUID->"bdb68138-5f2d-4c3a-a721-90e77ff97d38"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1093, 36, 160, 3, 99, "Title",ExpressionUUID->"2b3e8072-ce96-4699-b342-bc159e2e5660"],
Cell[1256, 41, 453, 9, 79, "Text",ExpressionUUID->"a4b170be-d10e-4be8-804b-73cbbc4ba106"],
Cell[CellGroupData[{
Cell[1734, 54, 166, 3, 56, "Subsection",ExpressionUUID->"93c0f94e-be0e-436f-826b-b4fe253ddc21"],
Cell[1903, 59, 363, 7, 70, "Input",ExpressionUUID->"05a527f5-d989-4de4-a651-2e6d404792c9"],
Cell[2269, 68, 2271, 59, 70, "Input",ExpressionUUID->"7f32c315-51df-4131-b3eb-e332fbecf302"],
Cell[4543, 129, 1918, 52, 70, "Input",ExpressionUUID->"b9eb888a-ad4c-4941-9903-a159f85e73e1"]
}, Closed]],
Cell[CellGroupData[{
Cell[6498, 186, 292, 4, 42, "Subsection",ExpressionUUID->"3aaa7217-7e77-4cca-9c01-b17b3344e060"],
Cell[6793, 192, 320, 7, 70, "Text",ExpressionUUID->"239fd2f6-1833-41df-8b13-f35c4d74f2dc"],
Cell[7116, 201, 3015, 90, 70, "Input",ExpressionUUID->"ebf62237-2bb4-4895-9b14-61df5eb1fb22"],
Cell[10134, 293, 271, 6, 70, "Text",ExpressionUUID->"459d94ed-7728-4fd2-b35c-a68b48647d95"],
Cell[10408, 301, 677, 17, 70, "Input",ExpressionUUID->"3de2ae8e-b029-4d40-9979-d689a5ddc999"],
Cell[11088, 320, 667, 12, 70, "Text",ExpressionUUID->"61d5996e-1fb1-495a-a2c9-5cf2390cb698"],
Cell[11758, 334, 2314, 56, 70, "Input",ExpressionUUID->"bbd21728-6340-46f4-8baa-a49d03aa3ead"],
Cell[14075, 392, 480, 8, 70, "Text",ExpressionUUID->"53b2d8f2-262b-40c4-bee9-88b26bf7a1a8"],
Cell[14558, 402, 2420, 56, 70, "Input",ExpressionUUID->"296f655f-1fc6-422a-8dac-12845181f193"],
Cell[16981, 460, 637, 15, 70, "Input",ExpressionUUID->"9ce01d7f-8ca2-44f5-8265-59fae72828c8"],
Cell[17621, 477, 1819, 45, 70, "Input",ExpressionUUID->"ba5a7955-6ebc-4a46-9fa0-c00bd6f8ce65"],
Cell[19443, 524, 473, 9, 70, "Text",ExpressionUUID->"c9d957b2-1021-4793-9009-fe382c9bb179"],
Cell[19919, 535, 2448, 60, 70, "Input",ExpressionUUID->"f332ed9f-6c5d-49e2-94fb-98d1d39a904b"],
Cell[22370, 597, 362, 8, 70, "Text",ExpressionUUID->"90065984-e02d-404a-81c8-a081b7871ca2"],
Cell[22735, 607, 3028, 52, 70, "Input",ExpressionUUID->"52c02210-fa62-48b4-be7e-fb1ee343ee1f"],
Cell[25766, 661, 810, 13, 70, "Text",ExpressionUUID->"2267a51e-6c61-4908-b153-ca67fe0e4ddf"],
Cell[26579, 676, 17030, 406, 70, "Input",ExpressionUUID->"0ea42274-238b-4ead-8550-ff50c2f3c92d"]
}, Closed]],
Cell[CellGroupData[{
Cell[43646, 1087, 397, 6, 42, "Subsection",ExpressionUUID->"4c72a7dc-4657-43f2-b831-3067981ed517"],
Cell[44046, 1095, 5960, 167, 70, "Input",ExpressionUUID->"5b321657-b1df-49cb-81b5-bf1b860f9f78"]
}, Closed]],
Cell[CellGroupData[{
Cell[50043, 1267, 216, 4, 42, "Subsection",ExpressionUUID->"a2ec0bbe-513b-4807-b40f-824ee8489a17"],
Cell[50262, 1273, 3796, 95, 319, "Input",ExpressionUUID->"4e2e97b2-d769-46f6-b2dd-d7615ba03ece"],
Cell[54061, 1370, 171, 3, 48, "Text",ExpressionUUID->"853ac518-3050-46ba-89c3-d0062cde6c27"],
Cell[54235, 1375, 367, 6, 63, "Input",ExpressionUUID->"3c5c64c3-48e1-426a-94c0-07dbc31e74a8"],
Cell[54605, 1383, 783, 19, 223, "Input",ExpressionUUID->"8992a82a-ffda-4a11-9542-0aaee32bcb0d"],
Cell[55391, 1404, 12109, 279, 841, "Input",ExpressionUUID->"7a17a464-7b39-4a93-b5f6-3f088b10f53d"]
}, Closed]],
Cell[CellGroupData[{
Cell[67537, 1688, 223, 4, 85, "Chapter",ExpressionUUID->"9b77a7a1-b845-4871-8d7a-602f69881625"],
Cell[67763, 1694, 150, 3, 48, "Text",ExpressionUUID->"8519ace4-b67f-41c7-a916-a1e007d5fa67"],
Cell[67916, 1699, 1926, 43, 382, "Input",ExpressionUUID->"df3dfe28-e441-47bc-abe8-0d9190538788"],
Cell[CellGroupData[{
Cell[69867, 1746, 167, 3, 56, "Subsection",ExpressionUUID->"d6aa8f0e-71bf-4780-babf-e34d8b9b7f86"],
Cell[70037, 1751, 890, 27, 141, "Input",ExpressionUUID->"9859b545-a5c6-4b92-b34b-0d0a1630fae8"],
Cell[CellGroupData[{
Cell[70952, 1782, 405, 10, 34, "Input",ExpressionUUID->"ff7d78b4-8570-4b33-84b4-8314e8123b15"],
Cell[71360, 1794, 3183, 45, 70, "Output",ExpressionUUID->"00e9003a-331e-442e-8ce3-f0e2497fe6ab"]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[74616, 1847, 261, 4, 99, "Title",ExpressionUUID->"2714e2f1-a98b-4077-b4d1-ba9bf7454843"],
Cell[CellGroupData[{
Cell[74902, 1855, 240, 4, 63, "Input",ExpressionUUID->"b13fb1f4-d71a-4c91-9c01-cc9d703d4ede"],
Cell[75145, 1861, 448, 8, 35, "Print",ExpressionUUID->"bf015fb4-57a4-48d8-a4d1-0574cd530922"]
}, Open  ]],
Cell[CellGroupData[{
Cell[75630, 1874, 168, 3, 56, "Subsection",ExpressionUUID->"547708db-bc01-49d4-9783-126dd8a205a9"],
Cell[75801, 1879, 182, 3, 48, "Text",ExpressionUUID->"fa24d4ee-2620-4135-a249-83d086a47687"],
Cell[75986, 1884, 525, 9, 63, "Input",ExpressionUUID->"46caef3b-b107-47f1-a530-eb30c0d4bceb"],
Cell[CellGroupData[{
Cell[76536, 1897, 1007, 17, 63, "Input",ExpressionUUID->"f39c1a72-b2da-4841-b7ac-8f095ffef269"],
Cell[77546, 1916, 1801, 28, 63, "Output",ExpressionUUID->"0e042405-0656-465a-bf27-3f6b62a4f070"]
}, Open  ]],
Cell[79362, 1947, 478, 10, 63, "Input",ExpressionUUID->"f5ff67b4-7466-4dff-85c8-924a04a4f89e"],
Cell[79843, 1959, 167, 3, 48, "Text",ExpressionUUID->"f7f8fbde-599a-4b0c-859f-8ab1428bab3a"],
Cell[80013, 1964, 612, 10, 63, "Input",ExpressionUUID->"5593c61b-b08a-4c92-906e-042e3ca852fc"],
Cell[CellGroupData[{
Cell[80650, 1978, 989, 17, 63, "Input",ExpressionUUID->"e3132b9d-c8d3-446f-8f2c-dd920e0aa0ad"],
Cell[81642, 1997, 1924, 29, 63, "Output",ExpressionUUID->"ce62d16a-908a-4dfc-8c96-63595e95a48d"]
}, Open  ]],
Cell[83581, 2029, 527, 11, 63, "Input",ExpressionUUID->"3142175a-2583-425a-b905-41dc1e3d0f56"],
Cell[CellGroupData[{
Cell[84133, 2044, 404, 9, 63, "Input",ExpressionUUID->"75ce99f5-3eb1-4593-bbde-0588bcef6523"],
Cell[84540, 2055, 1548, 21, 63, "Output",ExpressionUUID->"c111743f-9434-43b5-95d0-69503aca2eb0"]
}, Open  ]],
Cell[86103, 2079, 158, 3, 48, "Text",ExpressionUUID->"07c01816-9f65-487d-8fc6-ff931469c896"],
Cell[86264, 2084, 667, 11, 63, "Input",ExpressionUUID->"61444ab4-72ce-4d95-b700-d8239c5741da"],
Cell[CellGroupData[{
Cell[86956, 2099, 1047, 19, 63, "Input",ExpressionUUID->"9ffe6c06-b8e5-494c-9ab7-2e5856aa051f"],
Cell[88006, 2120, 1880, 29, 66, "Output",ExpressionUUID->"6481113b-c7fd-4a09-a484-0adc89570879"]
}, Open  ]],
Cell[89901, 2152, 585, 13, 63, "Input",ExpressionUUID->"ad968fa0-9cb0-4cca-a39a-bf0cf02f62f5"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[90535, 2171, 407, 6, 99, "Title",ExpressionUUID->"afa5c16a-da02-4911-bdf7-e6bdef97fa9d"],
Cell[CellGroupData[{
Cell[90967, 2181, 294, 5, 63, "Input",ExpressionUUID->"9317f807-46ca-4919-a2bd-993050066e43"],
Cell[91264, 2188, 431, 7, 35, "Print",ExpressionUUID->"bdc2e3d5-e0c6-4c86-a9a7-71e221e05e38"]
}, Open  ]],
Cell[91710, 2198, 318, 7, 79, "Text",ExpressionUUID->"0b32db2e-6a38-4841-a8e0-aa0a2bd30776"],
Cell[92031, 2207, 4262, 110, 510, "Input",ExpressionUUID->"91bec30f-8aa5-47c2-be32-be5c916eadb5"],
Cell[96296, 2319, 3732, 80, 271, "Input",ExpressionUUID->"acc251d5-98e9-4ec2-82be-a528553dd62e"],
Cell[CellGroupData[{
Cell[100053, 2403, 216, 4, 56, "Subsection",ExpressionUUID->"ccff9b63-4374-4aa1-83dc-e7c887b991fe"],
Cell[100272, 2409, 152, 3, 48, "Text",ExpressionUUID->"9afe8a8d-a246-4bcb-8811-b1a7d8c4ed7a"],
Cell[100427, 2414, 887, 20, 63, "Input",ExpressionUUID->"2da9287d-8262-496e-995d-d76d70ee814f"],
Cell[CellGroupData[{
Cell[101339, 2438, 184, 2, 63, "Input",ExpressionUUID->"815cadc6-dd36-4d61-815c-584862dab56e"],
Cell[101526, 2442, 2938, 60, 350, "Output",ExpressionUUID->"6c8f11dd-c781-4341-a048-9d2e8ee3e1ca"]
}, Open  ]],
Cell[CellGroupData[{
Cell[104501, 2507, 830, 14, 63, "Input",ExpressionUUID->"957707db-4e41-49f8-95bd-4b64c6ac1eba"],
Cell[105334, 2523, 2136, 34, 95, "Output",ExpressionUUID->"fd64e272-291b-44e8-99b6-9997de5215ef"]
}, Open  ]],
Cell[107485, 2560, 615, 13, 63, "Input",ExpressionUUID->"052c5b0b-6001-4407-bba9-2424bd370169"],
Cell[108103, 2575, 591, 12, 63, "Input",ExpressionUUID->"b239f8c9-073c-44dc-9e5f-94c0b17f07d9"],
Cell[108697, 2589, 150, 3, 48, "Text",ExpressionUUID->"edace532-cd1b-42ea-988d-b04131a4fca9"],
Cell[108850, 2594, 417, 8, 63, "Input",ExpressionUUID->"8451f892-6b64-4fcc-b8ee-0599e592463d"],
Cell[109270, 2604, 850, 14, 63, "Input",ExpressionUUID->"d35a8810-b296-4a74-be8b-901158501389"],
Cell[110123, 2620, 1196, 24, 95, "Input",ExpressionUUID->"b9f09362-39bd-4c71-9d02-da4503297e34"],
Cell[111322, 2646, 301, 7, 79, "Text",ExpressionUUID->"f4fdb21c-9b3d-4fbf-b43d-936745e2f115"],
Cell[111626, 2655, 515, 14, 95, "Input",ExpressionUUID->"d6e40327-cc40-426e-97c5-d7669aeb2157"],
Cell[112144, 2671, 950, 17, 63, "Input",ExpressionUUID->"24014112-07ff-411e-8b67-82ab8a73f38c"],
Cell[113097, 2690, 271, 6, 63, "Input",ExpressionUUID->"41fd183b-ff17-4585-8cd3-d35177b9c145"],
Cell[113371, 2698, 1012, 17, 63, "Input",ExpressionUUID->"aa189f33-04a2-4510-bb34-afccd560d845"],
Cell[114386, 2717, 894, 17, 95, "Input",ExpressionUUID->"68106386-e04f-4cbe-9560-75c4e77da5cc"],
Cell[115283, 2736, 471, 12, 95, "Input",ExpressionUUID->"cfa2d4b6-1ff6-40ee-ad5d-dbfabfdc0fb8"],
Cell[115757, 2750, 147, 3, 48, "Text",ExpressionUUID->"d24f5b4a-58c3-4e0d-800b-9bba94e422ed"],
Cell[115907, 2755, 538, 14, 63, "Input",ExpressionUUID->"44228d9c-a34a-499f-b79c-7dbc198c2c45"]
}, Open  ]],
Cell[CellGroupData[{
Cell[116482, 2774, 154, 3, 56, "Subsection",ExpressionUUID->"f4eac110-e932-4e31-93e7-09db3c12d76a"],
Cell[116639, 2779, 5699, 133, 287, "Input",ExpressionUUID->"bcf6b3c4-356c-4de3-b9be-759248f6a46d"],
Cell[122341, 2914, 642, 17, 63, "Input",ExpressionUUID->"27b82e4d-d306-4c6e-a19b-dbf2487addbf"],
Cell[122986, 2933, 1448, 41, 98, "Input",ExpressionUUID->"e85816af-a678-44c7-93d5-c3105b0c4474"],
Cell[124437, 2976, 637, 16, 63, "Input",ExpressionUUID->"9d1be9fd-527e-497d-9244-af2791f76f8e"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[125123, 2998, 176, 3, 99, "Title",ExpressionUUID->"8e4230e1-51eb-432e-9f30-6f5592d7a4d4"],
Cell[CellGroupData[{
Cell[125324, 3005, 247, 5, 63, "Input",ExpressionUUID->"5e617bbf-9e90-48d4-90e4-32321fd23d4c"],
Cell[125574, 3012, 333, 6, 35, "Print",ExpressionUUID->"f0f1ed6f-a835-4be8-a8f1-9205824197fd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[125944, 3023, 174, 4, 63, "Input",ExpressionUUID->"8ad90e10-75e1-47e5-9a3f-9587e4ba176b"],
Cell[126121, 3029, 401, 9, 41, "Message",ExpressionUUID->"af699f4c-f699-42c8-96e7-a9a095eab4a6"]
}, Open  ]],
Cell[126537, 3041, 23202, 551, 3803, "Input",ExpressionUUID->"fbebebb9-6800-456e-88aa-765e9fcf7ff9"],
Cell[149742, 3594, 216, 5, 48, "Text",ExpressionUUID->"651f1dc9-f7ff-41c9-b916-3934362c1502"],
Cell[149961, 3601, 629, 12, 63, "Input",ExpressionUUID->"7095c5a6-2cd1-4f6d-b3ad-62145c9d6e90"]
}, Open  ]]
}
]
*)

